Package: clean
Title: Fast and Easy Data Cleaning
Version: 2.0.0
Date: 2020-06-01
Authors@R: 
  person(
    given = c("Matthijs", "S."),
    family = "Berends",
    email = "m.s.berends@umcg.nl",
    role = c("aut", "cre"),
    comment = c(ORCID = "0000-0001-7620-1800"))
Description: A wrapper around the new 'cleaner' package, that allows
  data cleaning functions for classes 'logical', 'factor', 'numeric', 
  'character', 'currency' and 'Date' to make data cleaning fast and
  easy. Relying on very few dependencies, it provides smart guessing,
  but with user options to override anything if needed.
Depends: R (>= 3.0.0), cleaner (>= 1.2.0)
URL: https://github.com/msberends/cleaner
BugReports: https://github.com/msberends/cleaner/issues
License: GPL-2
Encoding: UTF-8
LazyData: true
RoxygenNote: 7.1.0
NeedsCompilation: no
Packaged: 2020-06-01 14:53:13 UTC; msberends
Author: Matthijs S. Berends [aut, cre]
    (<https://orcid.org/0000-0001-7620-1800>)
Maintainer: Matthijs S. Berends <m.s.berends@umcg.nl>
Repository: CRAN
Date/Publication: 2020-06-01 15:10:02 UTC
Built: R 4.6.0; ; 2026-04-28 15:35:30 UTC; unix

Package: clean
Title: Fast and Easy Data Cleaning
Version: 2.0.0
Date: 2020-06-01
Authors@R: 
  person(
    given = c("Matthijs", "S."),
    family = "Berends",
    email = "m.s.berends@umcg.nl",
    role = c("aut", "cre"),
    comment = c(ORCID = "0000-0001-7620-1800"))
Description: A wrapper around the new 'cleaner' package, that allows
  data cleaning functions for classes 'logical', 'factor', 'numeric', 
  'character', 'currency' and 'Date' to make data cleaning fast and
  easy. Relying on very few dependencies, it provides smart guessing,
  but with user options to override anything if needed.
Depends: R (>= 3.0.0), cleaner (>= 1.2.0)
URL: https://github.com/msberends/cleaner
BugReports: https://github.com/msberends/cleaner/issues
License: GPL-2
Encoding: UTF-8
LazyData: true
RoxygenNote: 7.1.0
NeedsCompilation: no
Packaged: 2020-06-01 14:53:13 UTC; msberends
Author: Matthijs S. Berends [aut, cre]
    (<https://orcid.org/0000-0001-7620-1800>)
Maintainer: Matthijs S. Berends <m.s.berends@umcg.nl>
Repository: CRAN
Date/Publication: 2020-06-01 15:10:02 UTC
Built: R 4.6.0; ; 2026-04-25 18:44:30 UTC; unix

# UPON REQUEST OF CRAN, THIS R PACKAGE WAS RENAMED TO `cleaner` AND CONSEQUENTLY THIS PROJECT HAS MOVED TO A NEW LOCATION: https://www.github.com/msberends/cleaner

**Website of this package: https://msberends.github.io/cleaner**

# Clean

[![Build Status](https://travis-ci.org/azawawi/perl6-clean.svg?branch=master)](https://travis-ci.org/azawawi/perl6-clean) [![Build status](https://ci.appveyor.com/api/projects/status/github/azawawi/perl6-clean?svg=true)](https://ci.appveyor.com/project/azawawi/perl6-clean/branch/master)

Provides a routine `clean` that takes an object and an anonymous code block
which takes an object that does `Cleanable`. This basically ensures that your
objects can be cleaned after your code block has finished running. Thus it
provides an object-oriented `clean` method (aka destructor).

## Example

```Perl6
# A class that needs to close or free resources
class Foo does Cleanable {

  # Guaranteed to be called once the anonymous block finishes execution
  method clean {
    # Close or free resources here
  }
}

clean(
  # The object we need to be cleaned up
  Foo.new,

  # The anonymous block
  -> $obj {
    # Do interesting stuff with $obj of type Cleanable
  }
);
```


## Installation

To install it using Panda (a module management tool bundled with Rakudo Star):

```
$ panda update
$ panda install Clean
```

## Testing

To run tests:

```
$ prove -e "perl6 -Ilib"
```

To run author tests, you need to manually install [Test::META](
https://github.com/jonathanstowe/Test-META):

```
$ panda install Test::META
$ TEST_AUTHOR=1 prove -e "perl6 -Ilib"
```

## Author

Ahmad M. Zawawi, azawawi on #perl6, https://github.com/azawawi/

## License

MIT License

`geneSigInList` <- 
function(geneList,allGenes,CategoryID2GeneID,refGenes = NULL, 
	minGenesInCategory=10,maxGenesInCategory=1000,verbose=TRUE, inBkg=FALSE,
	sigFDR = 0.1) {
     
	if(is.null(refGenes)) refGenes <- unique(allGenes)
	refCategories<-initializeCategories(CategoryID2GeneID, AllGeneIDs=refGenes,verbose=verbose, 
		minGenesInCategory = minGenesInCategory, maxGenesInCategory = maxGenesInCategory, inBkg = inBkg)
	sigCategories<-significantCategories(unique(geneList), refCategories=refCategories, verbose = verbose)
	if(verbose) print(sigCategories$categories[1:10,])
	list(sigCategories$categories[sigCategories$categories[,"FisherFDR"]<sigFDR,])
}

`r2cdt` <-
function (hr, hc, data, labels = TRUE, description = TRUE, file = "cluster.cdt", dec = ".") {
	n <- dim(data)[1]
	data <- as.data.frame(cbind(1, data))
	if (!description) {
		if (!labels) {
			data <- cbind(row.names(data), data)
		} else {
			data <- cbind(as.factor(data[, 2]), data)
		}
	} else {
		data <- cbind(as.factor(data[, 3]), data[, -3])
	}
	if (!labels) {
		data <- cbind(row.names(data), data)
	} else {
		data <- cbind(as.factor(data[, 3]), data[, -3])
	}
	GID <- paste("GENE", 1:n, "X", sep = "")
	data <- cbind(as.factor(GID), data)
	data <- data[hr$order, ]
	m <- dim(data)[2]
	data[, 5:m] <- data[, 5:m][hc$order]
	colnames(data)[5:m] <- colnames(data)[5:m][hc$order]
	##data[, 5:m] <- signif(data[, 5:m], digits = 4)
	levels(data[, 1]) <- c(levels(data[, 1]), "1", "GID", "AID", "EWEIGHT")
	levels(data[, 2]) <- c(levels(data[, 2]), "1", "UNIQID")
	levels(data[, 3]) <- c(levels(data[, 3]), "1", "NAME")
	data <- rbind(1, data)
	nom <- c("GID", "UNIQID", "NAME", "GWEIGHT", names(data)[-c(1,2, 3, 4)])
	names(data) <- nom
	data[1, 1] <- "EWEIGHT"
	data <- rbind(c("AID", NA, NA, NA, paste("ARRY", hc$order, "X", sep = "")), data)
	data[2, 2:4] <- NA
	if (dec == ",") {
		data <- apply(data, 2, function(u) { chartr(".", ",", u) })
		data[data == "NA"] <- NA
	}
	write.table(data, file = file, sep = "\t", row.names = FALSE, col.names = TRUE, na = "", quote = FALSE)
}

`call.treeview` <-
function(cdtFile = "cluster.cdt", treeViewPath = .fTreeViewPath, wait = FALSE) {
	if(Sys.info()["sysname"] == "Windows") {
		if(substr(path.expand(cdtFile), 2, 2) == ":") {   #if expands to absolute path
			cdtFile <- path.expand(cdtFile)               #explicitly make path absolute
		} else {                                          #else is relative file path
			cdtFile <- paste(getwd(), cdtFile, sep = "/") #explicitly make absolute
		}
	} else {
		if(substr(path.expand(cdtFile), 1, 1) == "/") { 
			cdtFile <- path.expand(cdtFile)
		} else {
			cdtFile <- paste(getwd(), cdtFile, sep = "/") 
		}
	}
	if(file.exists(cdtFile))
		system(paste("java -jar ",  treeViewPath, "TreeView.jar -new -r ", cdtFile, sep = ""), wait = wait)
	else if(file.exists(paste(cdtFile, "cdt", sep = ".")))	
		system(paste("java -jar ",  treeViewPath, "TreeView.jar -new -r ", paste(cdtFile, "cdt", sep = "."), sep = ""), wait = wait)
	else
		warning("The cdt file was not found. Aborted call to fTreeView")
}

`CLEAN` <-
function(tree, allGenes, CategoryID2GeneID, CategoryID2Desc, refGenes, maxSize=1000, minSize=10, maxNumOfClusters=NULL, sigFDR = 0.1,
		minGenesInCategory=10, maxGenesInCategory=1000, inBkg=TRUE, estimateNullDistribution = FALSE, 
		saveDataObjects = FALSE, verbose = TRUE) {
	
	l <- geneSigInClustering(tree = tree, allGenes = allGenes, CategoryID2GeneID = CategoryID2GeneID,
		refGenes = refGenes, maxSize = maxSize, minSize = minSize, maxNumOfClusters=maxNumOfClusters, 
		minGenesInCategory = minGenesInCategory, maxGenesInCategory = maxGenesInCategory, 
		verbose=verbose, inBkg = inBkg, sigFDR = sigFDR)
	
	geneMatrixSig <- matrix(1, dim(l$geneMatrixSigs)[1], dim(l$geneMatrixSigs)[2])
	refCategories <- l$refCategories 
	for(i in 1:length(l$sigCategories)) {
		clusterGenes <- refCategories$AllGeneIDs[l$allClusters[[i]]]
		if(!is.null(l$sigCategories[[i]])) {
			if(dim(l$sigCategories[[i]])[1] > 0) {
				for(j in 1:(dim(l$sigCategories[[i]])[1])) {
					categoryGenes <- unique(refCategories$CategoriesWithGenes[[as.character(l$sigCategories[[i]][j,1])]])
					index <- intersect(l$allClusters[[i]][!is.na(match(clusterGenes, categoryGenes))], which(geneMatrixSig[, i] > l$sigCategories[[i]][j,3]))
					geneMatrixSig[index, i] <- l$sigCategories[[i]][j,3]
				}
			}
		}
	}
	CLEANscore <- -log10(apply(geneMatrixSig, 1, min))

	if(estimateNullDistribution) {
		CLEANscore_nullDistr <- geneSigInClustering_nullDistr(allClusters = l$allClusters, 
			allGenes = allGenes[sample(length(allGenes),length(allGenes))], 
			CategoryID2GeneID = CategoryID2GeneID, refCategories = l$refCategories,  
			minGenesInCategory = minGenesInCategory, maxGenesInCategory = maxGenesInCategory, 
			verbose = verbose, inBkg = inBkg, sigFDR = sigFDR)
	} else {
		CLEANscore_nullDistr <- NULL
	}
	
	if(any(l$minFDR > 0)) cwCLEANscore <- pruneMinFDR(l) else cwCLEANscore <- l$sminFDR

	if(!saveDataObjects) {
		l$geneMatrixSigs <- NULL
		l$geneMatrixORs <- NULL
	}
	
	list(c(l, CategoryID2Desc = CategoryID2Desc, allGenes = list(allGenes), 
		CLEANscore = list(CLEANscore), cwCLEANscore = list(cwCLEANscore), 
		CLEANscore_nullDistr = list(CLEANscore_nullDistr)))
}

`convertFunctionalCategories` <-   
function (functionalCategories, fromSpecies = "h", toSpecies = "r", homologTable = "./homologene.data")
{	
	#this function was adapted from convertSmc() of the PGSEA package
	
	if(!file.exists(homologTable)) {
		warning(paste("File", homologTable, "not found. Please download from ftp://ftp.ncbi.nih.gov (see ?convertFunctionalCategories for details)."))
		#download.file("ftp://ftp.ncbi.nih.gov/pub/HomoloGene/current/homologene.data",destfile="homologene.data",mode="wb")
		NULL
	} else {
		fromSpecies <- switch(fromSpecies, h = 9606, r = 10116, m = 10090)
		toSpecies <- switch(toSpecies, h = 9606, r = 10116, m = 10090)
		homologTable <- read.delim(homologTable, col.names = c("HID", "TaxID", "GeneID", "Symbol", "Protein", "Protein-accession"))[, 1:3]
		hs <- which(homologTable$TaxID %in% fromSpecies)
		rn <- which(homologTable$TaxID %in% toSpecies)
		from <- homologTable[hs, ]
		to <- homologTable[rn, ]
		for (z in 1:length(functionalCategories)) {
			matched <- functionalCategories[[z]]
			ids <- to[match(from[match(matched, from[, "GeneID"]), "HID"], to[, "HID"]), "GeneID"]
			functionalCategories[[z]] <- unique(ids[!is.na(ids)])
			if (z%%50 == 0)	cat("finished ", z, "of", length(functionalCategories), "\n")
		}
		functionalCategories
	}
}

`.First.lib` <-
function(lib, pkg)
{
    #.fTreeViewPath <- paste(.Library, "/CLEAN/doc/", sep = "")
    .fTreeViewPath <- paste(system.file(package = "CLEAN"), "/doc/", sep = "")
    assign(".fTreeViewPath", paste(.Library, "/CLEAN/doc/", sep = ""), envir = sys.frame())
}

`getBinarySubTree` <-
function(tree,right=FALSE) {
	getRow <- function(merge,component,rows) {
		toDoList <- component
		doneList <- NULL
		while(length(toDoList)>0) {
			doneList <- c(toDoList[1], doneList)
			component <- merge[toDoList[1], 2:1]
			toDoList <- c(component[component>0], toDoList[-1])
		}
		doneList
	}
	n<-2-right
	component<-tree$merge[length(tree$merge)/n]
	if(component < 0) {
		element <-which(tree$merge==component)
		if(element <= (length(tree$merge)/2)){
			row<-element
		}else {
			row<-element-length(tree$merge)/2
		}
		res <- list(merge = NULL, 
					heights = tree$height[row],
					order = 1,
					labels = tree$labels[-component],
					method = tree$method,
					call = tree$call,
					dist.method = tree$dist.method)
	} else {
		which.merge.rows<-sort(getRow(tree$merge,component,NULL))
		merge.list <- tree$merge[which.merge.rows,]
		merge.height <- tree$height[which.merge.rows]
		pos.loc<-which(merge.list > 0)
		pos.elements <- sort(merge.list[pos.loc], index.return=TRUE)
		rank<-sort(pos.elements[[2]], index.return=TRUE)
		merge.list[pos.loc]<-rank[[2]]

		neg.loc<-which(merge.list < 0)
		neg.elements <- merge.list[neg.loc]
		minus.neg.elements <- -neg.elements
		neg.elements<-sort(minus.neg.elements, index.return=TRUE)
		rank<-sort(neg.elements[[2]], index.return=TRUE)
		merge.list[neg.loc]<- -rank[[2]]

		which.nodes <-sort(minus.neg.elements)
		names(which.nodes) <- NULL
		subtree.labels <- tree$labels[which.nodes]
		subtree.order <- tree$order[tree$labels[tree$order] %in% subtree.labels]
		
		old.order <- subtree.order
		subtree.order <- match(tree$labels[old.order], subtree.labels)
		res <- list(merge = merge.list,
					height = merge.height,
					order = subtree.order,
					labels = subtree.labels,
					method = tree$method,
					call = list(match.call(), tree$call),
					dist.method = tree$dist.method)
	}
	class(res) <- "hclust"
	res
}

`geneListEnrichment` <- 
function(geneList,
						allGenes,
						functionalCategories = NULL, 
						species = NULL,
						minGenesInCategory=10,
						maxGenesInCategory=1000,
						inBkg=TRUE,
						sigFDR = 0.1,
						verbose=TRUE) {
	if(is.null(functionalCategories)) {
		functionalCategories <- "GO" #default is GO categories
	}
	if(is.character(functionalCategories)) {
		if(substr(functionalCategories,nchar(functionalCategories)-4,nchar(functionalCategories)) == "RData") {
			e1 <- new.env()
			load(file = functionalCategories, envir = e1)
			if(length(ls(envir = e1, pattern = "2[G,g][E,e][N,n][E,e]")) > 0) {
				l <- get(ls(envir = e1, pattern = "2[G,g][E,e][N,n][E,e]")[1], envir = e1)
				#names(l) <- names(functionalCategories)
				#if(is.null(names(l))) names(l) <- substr(functionalCategories, 1, nchar(functionalCategories)-6)
				CategoryID2GeneID <- l
			} else {
				CategoryID2GeneID <- NA
				warning(paste("No functional categories found in file", functionalCategories, "-  No functional clustering annotation generated."))
			}
			if(length(ls(envir = e1, pattern = "2[D,d][E,e][S,s][C,c]")) > 0) {
				l <- get(ls(envir = e1, pattern = "2[D,d][E,e][S,s][C,c]")[1], envir = e1)
				#names(l) <- names(functionalCategories)
				#if(is.null(names(l))) names(l) <- substr(functionalCategories, 1, nchar(functionalCategories)-6)
				CategoryID2Desc <- l
			} 
			else CategoryID2Desc <- NA
		} else {
			functionalCategories <- getFunctionalCategories(functionalCategories, species)
			CategoryID2GeneID <- functionalCategories[[1]][[1]]
			if(length(functionalCategories[[1]]) > 1) 
				CategoryID2Desc <- functionalCategories[[1]][[2]]
			else CategoryID2Desc <- NA
		}
	} else {   #functionalCategories is a list
		l <- functionalCategories[[1]]
		CategoryID2GeneID <- l
		if(length(functionalCategories) > 1) 
			CategoryID2Desc <- functionalCategories[[2]]
		else CategoryID2Desc <- NA
	}
	categories <- as.data.frame(geneSigInList(geneList=geneList, allGenes=allGenes, CategoryID2GeneID=CategoryID2GeneID,  
		minGenesInCategory=minGenesInCategory, maxGenesInCategory=maxGenesInCategory, verbose=verbose, inBkg=inBkg, sigFDR = sigFDR))
	cbind(categories[,1], Description = CategoryID2Desc[match(categories[,1], CategoryID2Desc[,1]),2], categories[,-1])
}

`funcClustAnnot` <-
function(data = NULL, 
		rclust = NULL, 
		cclust = NULL, 
		funcCategories = NULL, 
		fClustAnnotations = NULL,
		bkgList = NULL,
		file = "cluster", 
		maxSize=1000, 
		minSize=10, 
		minGenesInCategory=10,
		maxGenesInCategory=1000,
		minSigsInCategory=2,
		inBkg=TRUE,
		sigFDR = 0.1,
		addCLEANscore2cdt = TRUE,
		species = NULL,
		estimateNullDistribution = FALSE,
		atr.distance="euc",
		gtr.distance="euc",
		dec='.',
		digits=5,
		verbose=TRUE, 
		saveDataObjects = FALSE,
		sampleDesc = NULL,
		callTreeView = FALSE) {
	warning("funcClustAnnot() is deprecated.  Please use generateTreeViewFiles() or runCLEAN() instead")
	generateTreeViewFiles(data = data, rclust = rclust, cclust = cclust, functionalCategories = funcCategories,
		fClustAnnotations = fClustAnnotations, bkgList = bkgList, file = file, maxSize = maxSize, minSize=minSize,
		minGenesInCategory = minGenesInCategory, maxGenesInCategory = maxGenesInCategory, 
		inBkg = inBkg, sigFDR = sigFDR, addCLEANscore2cdt = addCLEANscore2cdt,
		species = species, estimateNullDistribution = estimateNullDistribution, dec=dec, 
		verbose = verbose, saveDataObjects = saveDataObjects,
		sampleDesc = sampleDesc, callTreeView = callTreeView)
}

`genesInEnrichedCategories` <- 
function(categoryIDs, geneList, funcCategories = NULL, species = NULL) {
	if(is.null(funcCategories)) funcCategories <- "GO"  #default is GO categories
	if(is.character(funcCategories)) {
		if(substr(funcCategories,nchar(funcCategories)-4,nchar(funcCategories)) == "RData") {
			e1 <- new.env()
			load(file = funcCategories, envir = e1)
			if(length(ls(envir = e1, pattern = "2[G,g][E,e][N,n][E,e]")) > 0) {
				l <- get(ls(envir = e1, pattern = "2[G,g][E,e][N,n][E,e]")[1], envir = e1)
				#names(l) <- names(funcCategories)
				#if(is.null(names(l))) names(l) <- substr(funcCategories, 1, nchar(funcCategories)-6)
				CategoryID2GeneID <- l
			} else {
				CategoryID2GeneID <- NA
				warning(paste("No functional categories found in file", funcCategories, "-  No functional clustering annotation generated."))
			}
			if(length(ls(envir = e1, pattern = "2[D,d][E,e][S,s][C,c]")) > 0) {
				l <- get(ls(envir = e1, pattern = "2[D,d][E,e][S,s][C,c]")[1], envir = e1)
				#names(l) <- names(funcCategories)
				#if(is.null(names(l))) names(l) <- substr(funcCategories, 1, nchar(funcCategories)-6)
				CategoryID2Desc <- l
			} else 
				CategoryID2Desc <- list(NA)
		} else {
			l <- getFunctionalCategories(funcCategories, species)
			if(length(l) > 0) {
				CategoryID2GeneID <- l[[1]][[1]]
				if(length(l[[1]]) > 1) {
					CategoryID2Desc <- l[[1]][[2]]
				} else {
					CategoryID2Desc <- list(NA)
				}
			} else {
				CategoryID2GeneID <- NA
				CategoryID2Desc <- NA
				warning(paste("functional categories", funcCategories, "not found.  No functional clustering annotation generated."))
			}
		}
	} else {   #funcCategories is a list
		l <- funcCategories[[1]]
		CategoryID2GeneID <- l
		if(length(funcCategories) > 1)
			CategoryID2Desc <- funcCategories[[2]]
		else CategoryID2Desc <- list(NA)
	}
	genesInCategories <- sapply(categoryIDs, function(id) intersect(CategoryID2GeneID[[as.character(id)]], geneList))
	enrichedGenes <- matrix(rep(FALSE, length(geneList)*length(categoryIDs)), length(categoryIDs))
	for(i in 1:length(genesInCategories)) {
		enrichedGenes[i,match(genesInCategories[[i]], geneList)] <- TRUE
	}
	colnames(enrichedGenes) <- geneList
	cbind(CategoryID2Desc[match(categoryIDs, CategoryID2Desc[,1]),], enrichedGenes)
}

`nonHierarchicalClustering` <-
function(clustering, data = NULL, k = NULL, nRepeats = 1, ...) {
#usage:
# data(gimmOut)
# d <- nonHierarchicalClustering(function(m, k, ...) kmeans(m, k, ...)$cluster, gimmOut$clustData[,-(1:2)], nstart = 10) # all possible cluster numbers (k)
# funcClustAnnot(gimmOut$clustData, d, NA, callTreeView=T)
# d <- nonHierarchicalClustering(function(m, k, ...) kmeans(m, k, ...)$cluster, gimmOut$clustData[,-(1:2)], 4, nstart = 10) # k = 4
# funcClustAnnot(gimmOut$clustData, d, NA, callTreeView=T)
# d2 <- nonHierarchicalClustering(function(m, k, ...) kmeans(m, k, ...)$cluster, t(gimmOut$clustData[,-(1:2)]), 9, nstart = 10) #sample clustering
# funcClustAnnot(gimmOut$clustData, d, d2, callTreeView=T)
	if(is.function(clustering)) {
		if(is.null(k)) {
			k <- 2:round(dim(data)[1]/2)
			k <- rep(k, each = nRepeats)
		}
		if(is.null(data)) {
			warning("data = NULL, no clustering generated.")
			clustering <- NULL
		} else {
			clustering <- t(sapply(k, function(i) clustering(data, i, ...)))
		}
	} else if(is.vector(clustering)) {
		clustering <- t(clustering)
	}
	n <- dim(clustering)[2]
	m <- dim(clustering)[1]
	d <- matrix(0, n, n) 
	for(i in 1:m) {
		cl <- split(1:n, clustering[i,])
		for(j in 1:length(cl)) {
			index <- cl[[j]]
			d[index, index] <- d[index, index] + 1
		}
	}
	#d <- as.dist(1-d/m)
	d <- as.dist(1-d/m + runif(length(d), 0, 0.05))
	#d <- hclust(d, method = "average")
	#d$labels <- 1:n
	d
}

`runCLEAN` <-
function(data = NULL, 
		rclust = NULL, 
		functionalCategories = NULL, 
		bkgList = NULL,
		file = "cluster", 
		maxSize=1000, 
		minSize=10, 
		maxNumOfClusters=NULL,
		minGenesInCategory=10,
		maxGenesInCategory=1000,
		inBkg=TRUE,
		sigFDR = 0.1,
		species = NULL,
		estimateNullDistribution = FALSE,
		verbose=TRUE, 
		saveDataObjects = FALSE) {
	if(is.null(data)) { 
		if(file.access(paste(file, "RData", sep = "."))==0) 
			data <- paste(file, "RData", sep = ".")
		else if(file.access(paste(file, "cdt", sep = "."))==0)
			data <- paste(file, "cdt", sep = ".")
		else 
			data <- paste(file, "txt", sep = ".")
	}
	fromCdtFile <- FALSE
	if(is.character(data)) { #is a file name
		if(substr(data,nchar(data)-4,nchar(data)) == "RData") {
			e1 <- new.env()
			load(file = data, envir = e1)
			data <- get(ls(envir = e1, pattern = "gimmOut")[1], envir = e1)
		}
		else if(substr(data,nchar(data)-2,nchar(data)) == "cdt") {
			data <- cdt2r(data)
			fromCdtFile <- TRUE
		} else {
			data <- read.table(file = data, sep = "\t", header = TRUE, stringsAsFactors = FALSE)
		}
	}
	if(is.matrix(data)) {
		cdt <- cbind(ID=rownames(data), NAME=as.character(rownames(data)), data) #rownames are assumed to be gene IDs
	} else if(is.data.frame(data)) {
		if(is.numeric(data[,2]) & #second column contains data
		length(grep("descr", colnames(data)[2], ignore.case=TRUE)) <= 0 &
		length(grep("name", colnames(data)[2], ignore.case=TRUE)) <= 0) {
			if(length(grep("id",colnames(data)[1], ignore.case=TRUE)) > 0 |   #if first column contains gene id
				length(grep("acc",colnames(data)[1], ignore.case=TRUE)) > 0 |
				!is.numeric(data[, 1])) {
				cdt <- cbind(ID=data[,1], NAME=as.character(data[,1]), data[,-1])
				warning("data[, 2] is numeric.  Assuming data[, 1] = ID column, data[, 2] data column")
			} else { #first column contains data
				cdt <- cbind(ID=rownames(data), NAME=as.character(rownames(data)), data) #rownames are assumed to be gene IDs
				warning("data[, 1:2] are numeric.  Assuming all columns to contain data.")
			}
	
		} else {
			cdt <- data
		}
	} else { #is gimmOut object
		cdt <- data$clustData
		if(is.null(rclust)) rclust <- data$hGClustData
	}
	if(is.null(rclust)) rclust <- "euclidean"  #default is hclust with euclidean distance
	run.CLEAN = TRUE
	if(length(rclust) == 1) {
		if(is.na(rclust)) {                        #no gene clustering specified
			run.CLEAN <- FALSE
		}
	}
	if(is.character(rclust)) {  #is filename or dist method
		if(substr(rclust,nchar(rclust)-2,nchar(rclust)) == "gtr") { #import gtr file
			rclust <- gtr2r(rclust)
		} else if(substr(rclust,nchar(rclust)-1,nchar(rclust)) == "zm") { #import zm file
			rclust <-data.matrix(scan(rclust))
			rclust <- 1 - matrix(rclust,sqrt(length(rclust)))
		} else {
			rclust <- dist(cdt[,-(1:2)], method = rclust) #compute distance matrix from data
			fromCdtFile <- FALSE
		}
	}
	if(is.numeric(rclust)) {
		gtr <- hclust(as.dist(rclust), method="average") 
		gtr$labels <- 1:nrow(cdt) 
	}
	else gtr <- rclust
	if(fromCdtFile) cdt <- cdt[order(gtr$order),]
	if(is.null(gtr$labels)) gtr$labels <- 1:nrow(cdt)
	if(length(intersect(gtr$labels, 1:nrow(cdt))) < nrow(cdt)) {
		gtr$labels <- 1:nrow(cdt)
		warning("rclust$labels incompatible, reassigned as rclust$labels<-1:nrow(cdt)")
	}
	if(is.null(functionalCategories)) functionalCategories <- "GO"  #default is GO categories
	if(length(functionalCategories) == 1) {
		if(is.na(functionalCategories)) {  #no functional categories specified
			run.CLEAN <- FALSE
		}
	}
	if(run.CLEAN) {
		if(!is.list(functionalCategories)) functionalCategories <- as.list(unique(functionalCategories))
		CategoryID2GeneID <- list()
		CategoryID2Desc <- list()
		run.CLEAN <- rep(TRUE, length(functionalCategories))
		for(i in 1:length(functionalCategories)) {
			if(is.character(functionalCategories[[i]])) {
				if(substr(functionalCategories[[i]],nchar(functionalCategories[[i]])-4,nchar(functionalCategories[[i]])) == "RData") {
					e1 <- new.env()
					load(file = functionalCategories[[i]], envir = e1)
					if(length(ls(envir = e1, pattern = "2[G,g][E,e][N,n][E,e]")) > 0) {
						l <- list(get(ls(envir = e1, pattern = "2[G,g][E,e][N,n][E,e]")[1], envir = e1))
						names(l) <- names(functionalCategories)[i]
						if(is.null(names(l))) names(l) <- substr(functionalCategories[[i]], 1, nchar(functionalCategories[[i]])-6)
						CategoryID2GeneID <- c(CategoryID2GeneID, l)
					} else {
						run.CLEAN[i] <- FALSE
						CategoryID2GeneID <- c(CategoryID2GeneID, list(NA))
						warning(paste("No functional categories found in file", functionalCategories[[i]], "-  No functional clustering annotation generated."))
					}
					if(length(ls(envir = e1, pattern = "2[D,d][E,e][S,s][C,c]")) > 0) {
						l <- list(get(ls(envir = e1, pattern = "2[D,d][E,e][S,s][C,c]")[1], envir = e1))
						names(l) <- names(functionalCategories)[i]
						if(is.null(names(l))) names(l) <- substr(functionalCategories[[i]], 1, nchar(functionalCategories[[i]])-6)
						CategoryID2Desc <- c(CategoryID2Desc, l)
					} else CategoryID2Desc <- c(CategoryID2Desc, list(NA))
				} else {
					l1 <- getFunctionalCategories(functionalCategories[[i]], species)
					if(length(l1) > 0) {
						l <- l1[[1]][1]
						names(l) <- functionalCategories[[i]]
						CategoryID2GeneID <- c(CategoryID2GeneID, l)
						if(length(l1[[1]]) > 1) {
							l <- l1[[1]][2]
							names(l) <- functionalCategories[[i]]
							CategoryID2Desc <- c(CategoryID2Desc, l)
						} 
						else CategoryID2Desc <- c(CategoryID2Desc, list(NA))
					} else {
						run.CLEAN[i] <- FALSE
						CategoryID2GeneID <- c(CategoryID2GeneID, list(NA))
						CategoryID2Desc <- c(CategoryID2Desc, list(NA))
						warning(paste("functional categories", functionalCategories[[i]], "not found.  No functional clustering annotation generated."))
					}
				}
			} else {   #functionalCategories[[i]] is a list
				l <- functionalCategories[[i]][1]
				names(l) <- names(functionalCategories)[i]
				CategoryID2GeneID <- c(CategoryID2GeneID, l)
				if(length(functionalCategories[[i]]) > 1) {
					l <- functionalCategories[[i]][2]
					names(l) <- names(functionalCategories)[i]
					CategoryID2Desc <- c(CategoryID2Desc, l)
				}
				else CategoryID2Desc <- c(CategoryID2Desc, list(NA))
			}
		}
	}
	if(any(run.CLEAN)) {
		fClustAnnotations <- list()
		for(i in 1:length(run.CLEAN)) {
			if(run.CLEAN[i]) {
				l <- CLEAN(tree = gtr, allGenes=cdt[,1], CategoryID2GeneID=CategoryID2GeneID[[i]],
					CategoryID2Desc = CategoryID2Desc[i], refGenes = unique(bkgList), maxSize=maxSize,
					minSize=minSize, maxNumOfClusters=maxNumOfClusters, minGenesInCategory=minGenesInCategory, 
					maxGenesInCategory=maxGenesInCategory, verbose=verbose,inBkg=inBkg, sigFDR=sigFDR, 
					saveDataObjects=saveDataObjects, estimateNullDistribution = estimateNullDistribution)
				names(l) <- names(CategoryID2GeneID)[i]
				fClustAnnotations <- c(fClustAnnotations, l)
			}
		}
	}
	if(saveDataObjects) { 
		save(fClustAnnotations, file = paste(file,"RData",sep ="."))
	}
	invisible(fClustAnnotations)
}

`initializeCategories` <-
function(CategoryID2GeneID, AllGeneIDs = NULL, minGenesInCategory=10, maxGenesInCategory=1000, inBkg = TRUE, verbose = TRUE){
	
	if(is.null(AllGeneIDs)){
		AllGeneIDs <- unique(unlist(CategoryID2GeneID))
	}
	if(verbose) cat("Total Number of categories \n",length(CategoryID2GeneID),"\n")
	
	#Getting frequencies of genes on the microarray in each category
	GenesInCategories<-unlist(lapply(CategoryID2GeneID,function(x) length(intersect(x,AllGeneIDs))))
	nonEmptyCategories<-GenesInCategories > 0
	GenesInCategories<-GenesInCategories[nonEmptyCategories]
	allGenesInCategories<-intersect(unique(unlist(CategoryID2GeneID[nonEmptyCategories])),AllGeneIDs)
	nGenesInCategories<-length(allGenesInCategories)
	if(verbose) cat("Number of genes on microarray represented in functional categories\n",nGenesInCategories,"\n")
	CategoriesWithGenes<-names(GenesInCategories)
	CategoriesWithGenes<-CategoryID2GeneID[CategoriesWithGenes]

	if(verbose) cat("Number of categories with genes from the list\n",length(GenesInCategories),"\n")

	minMaxCategories<-names(GenesInCategories[GenesInCategories>=minGenesInCategory & GenesInCategories<=maxGenesInCategory])
	nMinMaxCategories<-length(minMaxCategories)
	if(verbose) cat("Number of categories with more than ",minGenesInCategory," genes\n",nMinMaxCategories,"\n")
	#Getting all genes in such categories
	allGenes <- CategoriesWithGenes[minMaxCategories]
	CategoriesWithGenesMinMax<-allGenes
	allGenes<-intersect(unique(unlist(CategoriesWithGenesMinMax)), allGenesInCategories)
	CategoriesWithGenes <- CategoriesWithGenesMinMax

	if(inBkg) AllGeneIDs <- allGenes
	if(inBkg) nAllGenes<-length(allGenes)
	else nAllGenes<-length(AllGeneIDs)
	
	if(inBkg & verbose) cat("Only genes in occuring in considered categories are used in the analysis\n")
	if(verbose) cat("Number of genes in the background list of categories\n",nAllGenes,"\n")

	CategoriesWithGenes <- lapply(CategoriesWithGenes, function(l) intersect(AllGeneIDs, l))

	list(GenesInCategories=GenesInCategories[names(CategoriesWithGenes)],CategoriesWithGenes=CategoriesWithGenes,
		allGenesInCategories=allGenesInCategories,nGenesInCategories=nGenesInCategories, AllGeneIDs=AllGeneIDs)
}

`significantCategories` <-
function(genes, refCategories, lean=TRUE, verbose = TRUE){

	#Selecting categories with at least minGenesInCategory and no more than maxGenesInCategory genes
#	minMaxCategories<-names(refCategories$GenesInCategories[refCategories$GenesInCategories>=minGenesInCategory & 
#														refCategories$GenesInCategories<=maxGenesInCategory])
	minMaxCategories <- names(refCategories$GenesInCategories)

	nMinMaxCategories<-length(minMaxCategories)
#	if(verbose) cat("Number of categories with more than ",minGenesInCategory," genes\n",nMinMaxCategories,"\n")

	#Getting all genes in such categories
#	allGenes<-refCategories$CategoriesWithGenes[minMaxCategories]
#	CategoriesWithGenesMinMax<-allGenes
#	allGenes<-intersect(unique(unlist(CategoriesWithGenesMinMax)),refCategories$allGenesInCategories)

	allGenes <- refCategories$AllGeneIDs

	genesInUsedCategories<-intersect(genes,allGenes)

#	nGenes<-length(genes)
#	if(inBkg) nGenes<-length(genesInUsedCategories)
	nGenes<-length(genesInUsedCategories)
#	if(inBkg) nAllGenes<-length(allGenes)
#	else nAllGenes<-length(refCategories$AllGeneIDs)
	nAllGenes<-length(allGenes)
	nComplementGenes<-nAllGenes-nGenes
	#if(inBkg & verbose) cat("Only genes in occuring in considered categories are used in the analysis\n")
#	if(verbose) cat("Number of genes in the background list of categories\n",nAllGenes,"\n")
	if(verbose) cat("Number of genes\n",nGenes,"\n")

	#Testing categories with at least one gene
	nGenesInCategoryAll<-unlist(lapply(refCategories$CategoriesWithGenes,function(x) length(intersect(x,genes))))
	nonEmptyCategories<-nGenesInCategoryAll>0
	if(verbose) cat("Number of categories with significant genes\n",sum(nonEmptyCategories),"\n")
	nGenesInCategoryAll<-nGenesInCategoryAll[nonEmptyCategories]
	CategoriesWithGenes<-names(nGenesInCategoryAll)
	matchWithMinMax<-match(CategoriesWithGenes,minMaxCategories)
	CategoriesWithGenes<-CategoriesWithGenes[!is.na(matchWithMinMax)]
	nGenesInCategoryAll<-nGenesInCategoryAll[!is.na(matchWithMinMax)]
	if(verbose) cat("Number of categories with significant genes tested \n",sum(!is.na(matchWithMinMax)),"\n")


	#nGenesInCategories<-NULL
	#nGenesInCategoriesAll<-NULL
	#FisherPValues<-NULL
	#logOR<-NULL
	
#	if(inBkg) m <- unlist(lapply(refCategories$CategoriesWithGenes[CategoriesWithGenes], 
#		function(l) length(intersect(allGenes, l))))
#	else m <- unlist(lapply(refCategories$CategoriesWithGenes[CategoriesWithGenes], 
#		function(l) length(intersect(refCategories$AllGeneIDs, l))))
	if(sum(!is.na(matchWithMinMax)) > 0) {
		m <- unlist(lapply(refCategories$CategoriesWithGenes[CategoriesWithGenes], length))
		n <- nAllGenes - m
		k <- nGenes
		#a <- unlist(lapply(refCategories$CategoriesWithGenes[CategoriesWithGenes], function(l) length(intersect(genes, l))))
		a <- nGenesInCategoryAll
		FisherPValues <- phyper(a - 1, m, n, k, lower.tail = FALSE)
		nGenesInCategories <- a
		nGenesInCategoriesAll <- m
		logOR <- log((a+1)*(n - k + a + 1)/((k - a + 1)*(m - a + 1)))
		#no fudge factor if sum(twoBytwo)==4 --> ever an issue?
	} else {
		FisherPValues <- NULL
		nGenesInCategories <- NULL
		nGenesInCategoriesAll <- NULL
		logOR <- NULL
	}
#	for(x in CategoriesWithGenes){
#		currentCategoryGenes<-unique(unlist(refCategories$CategoriesWithGenes[x]))
#		nGenesInCategory<-length(intersect(genes,currentCategoryGenes))
#		nGenesNOTinCategory<-nGenes-nGenesInCategory
#		if(inBkg) nComplementGenesInCategory<-length(intersect(setdiff(allGenes,genes),currentCategoryGenes))
#		else nComplementGenesInCategory<-length(intersect(setdiff(refCategories$AllGeneIDs,genes),currentCategoryGenes))
#		nComplementGenesNOTinCategory<-nComplementGenes-nComplementGenesInCategory
#		twoBytwo<-matrix(c(nGenesInCategory,nGenesNOTinCategory,nComplementGenesInCategory,nComplementGenesNOTinCategory), byrow=TRUE,ncol=2)
#		FisherPValues<-c(FisherPValues,fisher.test(twoBytwo, alternative = "greater")$p.value)
#		if(sum(twoBytwo)==4) logOR<-c(logOR,log((twoBytwo[1,1]*twoBytwo[2,2])/(twoBytwo[1,2]*twoBytwo[2,1])))
#		else logOR<-c(logOR,log(((twoBytwo[1,1]+1)*(twoBytwo[2,2]+1))/((twoBytwo[1,2]+1)*(twoBytwo[2,1]+1))))
#		nGenesInCategories<-c(nGenesInCategories,nGenesInCategory)
#		nGenesInCategoriesAll<-c(nGenesInCategoriesAll,nComplementGenesInCategory+nGenesInCategory)
#	}
	nPs<-length(FisherPValues)
	if(nPs>0){
		pOrder<-order(FisherPValues)
		pOriginal<-order(pOrder)
		FisherFDR<-FisherPValues[pOrder]*nMinMaxCategories/(1:nPs)
		for(i in 1:nPs) FisherFDR[i]<-min(FisherFDR[i:nPs],1)
		FisherFDR<-FisherFDR[pOriginal]
		oPvalues<-order(FisherPValues)
		CategoriesWithAllGenes<-refCategories$CategoriesWithGenes[CategoriesWithGenes]
		if(lean) list(categories=data.frame(list(ID=CategoriesWithGenes[oPvalues],list(FisherPValue=unlist(FisherPValues[oPvalues]),FisherFDR=FisherFDR[oPvalues],
			nGenesInCategory=nGenesInCategories[oPvalues],nAllGenesInCategory=nGenesInCategoriesAll[oPvalues],logOR=logOR[oPvalues]))))
		else list(categories=data.frame(list(ID=CategoriesWithGenes[oPvalues],list(FisherPValue=unlist(FisherPValues[oPvalues]),FisherFDR=FisherFDR[oPvalues],
			nGenesInCategory=nGenesInCategories[oPvalues],nAllGenesInCategory=nGenesInCategoriesAll[oPvalues],logOR=logOR[oPvalues]))),
			geneNumbers=list(nGenes=nGenes,nAllGenes=nAllGenes),genes=genes,allGenes=allGenes,CategoriesWithAllGenes=CategoriesWithAllGenes)
	}
	else NULL
}

`generateTreeViewFiles` <-
function(data = NULL, 
		rclust = NULL, 
		cclust = NULL, 
		functionalCategories = NULL, 
		fClustAnnotations = NULL,
		bkgList = NULL,
		file = "cluster", 
		maxSize=1000, 
		minSize=10, 
		maxNumOfClusters=NULL,
		minGenesInCategory=10,
		maxGenesInCategory=1000,
		inBkg=TRUE,
		sigFDR = 0.1,
		addCLEANscore2cdt = TRUE,
		species = NULL,
		estimateNullDistribution = FALSE,
		dec='.',
		verbose=TRUE, 
		saveDataObjects = FALSE,
		sampleDesc = NULL,
		callTreeView = FALSE) {
	if(is.null(data)) { 
		if(file.access(paste(file, "RData", sep = "."))==0) 
			data <- paste(file, "RData", sep = ".")
		else if(file.access(paste(file, "cdt", sep = "."))==0)
			data <- paste(file, "cdt", sep = ".")
		else 
			data <- paste(file, "txt", sep = ".")
	}
	fromCdtFile <- FALSE
	if(is.character(data)) { #is a file name
		if(substr(data,nchar(data)-4,nchar(data)) == "RData") {
			e1 <- new.env()
			load(file = data, envir = e1)
			data <- get(ls(envir = e1, pattern = "gimmOut")[1], envir = e1)
		}
		else if(substr(data,nchar(data)-2,nchar(data)) == "cdt") {
			data <- cdt2r(data)
			fromCdtFile <- TRUE
		} else {
			data <- read.table(file = data, sep = "\t", header = TRUE, stringsAsFactors = FALSE)
		}
	}
	if(is.matrix(data)) {
		cdt <- cbind(ID=rownames(data), NAME=as.character(rownames(data)), data) #rownames are assumed to be gene IDs
	} else if(is.data.frame(data)) {
		if(is.numeric(data[,2]) & #second column contains data
				length(grep("descr", colnames(data)[2], ignore.case=TRUE)) <= 0 &
				length(grep("name", colnames(data)[2], ignore.case=TRUE)) <= 0) { 
			if(length(grep("id",colnames(data)[1], ignore.case=TRUE)) > 0 |   #if first column contains gene id
				length(grep("acc",colnames(data)[1], ignore.case=TRUE)) > 0 |
				!is.numeric(data[, 1])) {
				cdt <- cbind(ID=data[,1], NAME=as.character(data[,1]), data[,-1])
				warning("data[, 2] is numeric.  Assuming data[, 1] = ID column, data[, 2] data column")
			} else { #first column contains data
				cdt <- cbind(ID=rownames(data), NAME=as.character(rownames(data)), data) #rownames are assumed to be gene IDs
				warning("data[, 1:2] are numeric.  Assuming all columns to contain data.")
			}
		} else {
			cdt <- data
		}
	} else { #is gimmOut object
			cdt <- data$clustData
			if(is.null(rclust)) rclust <- data$hGClustData
			if(is.null(cclust)) cclust <- data$hSClustData
	}
	make.gtr <- TRUE
	if(is.null(rclust)) rclust <- "euclidean"  #default is hclust with euclidean distance
	if(length(rclust) == 1) {
		if(is.na(rclust)) {                        #no gtr file desired but need dummy file
			rclust <- hclust(dist(1:(nrow(cdt))))
			rclust$order<-rclust$order[order(rclust$order)]
			make.gtr <- FALSE
			fromCdtFile <- FALSE
		}
	}
	if(is.character(rclust)) {  #is filename or dist method
		if(substr(rclust,nchar(rclust)-2,nchar(rclust)) == "gtr") { #import gtr file
			rclust <- gtr2r(rclust)
		} else if(substr(rclust,nchar(rclust)-1,nchar(rclust)) == "zm") { #import zm file
			rclust <-data.matrix(scan(rclust))
			rclust <- 1 - matrix(rclust,sqrt(length(rclust)))
		} else {
			rclust <- dist(cdt[,-(1:2)], method = rclust) #compute distance matrix from data
			fromCdtFile <- FALSE
		}
	}
	if(is.numeric(rclust)) {
		gtr <- hclust(as.dist(rclust), method="average") 
		gtr$labels <- 1:nrow(cdt)
	}
	else gtr <- rclust
	if(fromCdtFile) cdt <- cdt[order(gtr$order),]
	if(is.null(gtr$labels)) gtr$labels <- 1:nrow(cdt)
	if(length(intersect(gtr$labels, 1:nrow(cdt))) < nrow(cdt)) {
		gtr$labels <- 1:nrow(cdt)
		warning("rclust$labels incompatible, reassigned to rclust$labels<-1:nrow(cdt)")
	}
	make.atr <- TRUE
	if(is.null(cclust)) cclust <- 1-cor(cdt[,-(1:2)]) #default: hclust w/ pearson corr as similarity measure
	if(length(cclust) == 1) {
		if(is.na(cclust)) {                               #no atr file desired but need dummy file
				cclust <- hclust(dist(1:(ncol(cdt)-2))) 
				if(is.null(sampleDesc)) {
					cclust$order<-cclust$order[order(cclust$order)]
				} else {
					cclust$order<-(1:length(cclust$order))[order(sampleDesc)]
				}
				make.atr <- FALSE
		}
	}
	if(is.character(cclust)) {  #is filename or dist method
		if(substr(cclust,nchar(cclust)-2,nchar(cclust)) == "atr") { #import atr file
			cclust <- atr2r(cclust)
		} else if(substr(cclust,nchar(cclust)-1,nchar(cclust)) == "zm" | 
					substr(cclust,nchar(cclust)-2,nchar(cclust)) == "zm2") { #import zm file
			cclust <-data.matrix(scan(cclust))
			cclust <- 1 - matrix(cclust,sqrt(length(cclust)))
		} else {
			cclust <- dist(t(cdt[,-(1:2)]), method = cclust) #compute distance matrix from data
		}
	}
	if(is.numeric(cclust)) atr <- hclust(as.dist(cclust), method = "average")
	else atr <- cclust

	runCLEAN <- TRUE
	if(!is.null(fClustAnnotations)){
		runCLEAN <- FALSE
		if(is.character(fClustAnnotations)){ #is vector of (a) file name(s) for .RData object
		    fClustAnnotFiles <- fClustAnnotations
			fClustAnnotations <- list()
			for(i in 1:length(fClustAnnotFiles)) {
				e1 <- new.env()
				if(file.exists(fClustAnnotFiles[i])) {
					load(file = fClustAnnotFiles[i], envir = e1)
					fClustAnnotations<- c(fClustAnnotations, get("fClustAnnotations", envir = e1))
				} else {
					warning("File ", fClustAnnotFiles[i], " not found. Functional Cluster Annotations not loaded.")
				}
			}
		}
	}
	make.fni <- TRUE
	if(is.null(functionalCategories)) functionalCategories <- "GO"  #default is GO categories
	if(length(functionalCategories) == 1) {
		if(is.na(functionalCategories)) {  #no fni file desired
			runCLEAN <- FALSE
			make.fni <- FALSE
		}
	}
	if(runCLEAN) {
		if(!is.list(functionalCategories)) functionalCategories <- as.list(unique(functionalCategories))
		CategoryID2GeneID <- list()
		CategoryID2Desc <- list()
		runCLEAN <- rep(TRUE, length(functionalCategories))
		for(i in 1:length(functionalCategories)) {
			if(is.character(functionalCategories[[i]])) {
				if(substr(functionalCategories[[i]],nchar(functionalCategories[[i]])-4,nchar(functionalCategories[[i]])) == "RData") {
					e1 <- new.env()
					load(file = functionalCategories[[i]], envir = e1)
					if(length(ls(envir = e1, pattern = "2[G,g][E,e][N,n][E,e]")) > 0) {
						l <- list(get(ls(envir = e1, pattern = "2[G,g][E,e][N,n][E,e]")[1], envir = e1))
						names(l) <- names(functionalCategories)[i]
						if(is.null(names(l))) names(l) <- substr(functionalCategories[[i]], 1, nchar(functionalCategories[[i]])-6)
						CategoryID2GeneID <- c(CategoryID2GeneID, l)
					} else {
						runCLEAN[i] <- FALSE
						CategoryID2GeneID <- c(CategoryID2GeneID, list(NA))
						warning(paste("No functional categories found in file", functionalCategories[[i]], "-  No functional clustering annotation generated."))
					}
					if(length(ls(envir = e1, pattern = "2[D,d][E,e][S,s][C,c]")) > 0) {
						l <- list(get(ls(envir = e1, pattern = "2[D,d][E,e][S,s][C,c]")[1], envir = e1))
						names(l) <- names(functionalCategories)[i]
						if(is.null(names(l))) names(l) <- substr(functionalCategories[[i]], 1, nchar(functionalCategories[[i]])-6)
						CategoryID2Desc <- c(CategoryID2Desc, l)
					} else CategoryID2Desc <- c(CategoryID2Desc, list(NA))
				} else {
                    l1 <- getFunctionalCategories(functionalCategories[[i]], species)
					if(length(l1) > 0) {
						l <- l1[[1]][1]
						names(l) <- functionalCategories[[i]]
						CategoryID2GeneID <- c(CategoryID2GeneID, l)
						if(length(l1[[1]]) > 1) {
							l <- l1[[1]][2]
							names(l) <- functionalCategories[[i]]
							CategoryID2Desc <- c(CategoryID2Desc, l)
						} else CategoryID2Desc <- c(CategoryID2Desc, list(NA))
					} else {
						runCLEAN[i] <- FALSE
						CategoryID2GeneID <- c(CategoryID2GeneID, list(NA))
						CategoryID2Desc <- c(CategoryID2Desc, list(NA))
						warning(paste("functional categories", functionalCategories[[i]], "not found.  No functional clustering annotation generated."))
					}
				}
			} else {   #functionalCategories[[i]] is a list
				l <- functionalCategories[[i]][1]
				names(l) <- names(functionalCategories)[i]
				CategoryID2GeneID <- c(CategoryID2GeneID, l)
				if(length(functionalCategories[[i]]) > 1) {
					l <- functionalCategories[[i]][2]
					names(l) <- names(functionalCategories)[i]
					CategoryID2Desc <- c(CategoryID2Desc, l)
				}
				else CategoryID2Desc <- c(CategoryID2Desc, list(NA))
			}
		}
	}
	r2cdt(gtr,atr,cdt,labels=TRUE, description=TRUE,file=paste(file, "cdt",sep="."),dec=dec)
    if(!make.atr & !is.null(sampleDesc)) {
		cdtFromFile <- read.table(file=paste(file, "cdt",sep="."), header = FALSE, sep = "\t", quote = "", stringsAsFactors = FALSE, check.names=FALSE)
		data.start.col <- which(cdtFromFile[1,] == "GWEIGHT") + 1
		if (length(data.start.col) < 1) {
			if (colnames(cdt)[1] == "GID")
				data.start.col <- 4
			else data.start.col <- 3
		}
		newCdt <- cdtFromFile[,1:(data.start.col-1)]
		l <- data.start.col
		lSampleDesc <- levels(as.factor(sampleDesc))	
		for(f in lSampleDesc[-length(lSampleDesc)]) {
			l <- l + sum(sampleDesc == f)
			newCdt <- cbind(newCdt, cdtFromFile[,data.start.col:(l-1)], "")
			data.start.col <- l
		}
		l <- l + sum(sampleDesc == lSampleDesc[length(lSampleDesc)])
		newCdt <- cbind(newCdt, cdtFromFile[,data.start.col:(l-1)])
		write.table(newCdt, file=paste(file, "cdt",sep="."), sep="\t", row.names=FALSE, col.names=FALSE, quote=FALSE)
	}
	if(make.atr) 
		r2atr(atr,file=paste(file,"atr",sep ="."), dec=dec)
	if(make.gtr) {
		r2gtr(gtr,file=paste(file,"gtr",sep ="."), dec=dec)
		if(make.fni) {
			if(any(runCLEAN)) {
				fClustAnnotations <- list()
				for(i in 1:length(runCLEAN)) {
					if(runCLEAN[i]) {
						l <- CLEAN(tree = gtr, allGenes=cdt[,1], CategoryID2GeneID=CategoryID2GeneID[[i]],
							CategoryID2Desc = CategoryID2Desc[i], refGenes = unique(bkgList), maxSize=maxSize,
							minSize=minSize, maxNumOfClusters=maxNumOfClusters, minGenesInCategory=minGenesInCategory, 
							maxGenesInCategory=maxGenesInCategory, verbose=verbose,inBkg=inBkg, sigFDR=sigFDR, 
							saveDataObjects=saveDataObjects, estimateNullDistribution = estimateNullDistribution)
						names(l) <- names(CategoryID2GeneID)[i]
						fClustAnnotations <- c(fClustAnnotations, l)
					}
				}
			}
			if(length(fClustAnnotations) > 0) {
				if(addCLEANscore2cdt) {
					cwCLEANscore.all <- rep(0, dim(cdt)[1])
					for(i in 1:length(fClustAnnotations)) {
						#if(any(fClustAnnotations[[i]]$minFDR > 0)) 
						#	minFDR <- pruneMinFDR(fClustAnnotations[[i]])
						#else 
						#	minFDR <- fClustAnnotations[[i]]$sminFDR
						cwCLEANscore <- fClustAnnotations[[i]]$cwCLEANscore
						if(!is.null(cwCLEANscore)) {
							cwCLEANscore[cwCLEANscore > 300] <- 300
							sigLevels <- c(1, 3, 5, 10, 15, 20, 50, 100, 150, 200, 250, 299)
							if(max(cwCLEANscore) > 0) {
								newCdt<-insertCdt(cdtFile=paste(file, "cdt", sep = "."), insertVector = "", tree=gtr,columnName="", newCdtFile=NULL) #insert blank column
								for(sigLevel in sigLevels[sigLevels < max(cwCLEANscore)]) {
									newCdt<-insertCdt(cdtFile=paste(file, "cdt", sep = "."), insertVector=cwCLEANscore-sigLevel, 
										tree=gtr,columnName=paste(names(fClustAnnotations)[i], ": CLEANscore-", sigLevel, sep = ""), newCdtFile=NULL)
								}
							}
							cwCLEANscore.all <- apply(cbind(cwCLEANscore.all,cwCLEANscore), 1, max)
						}
					}
					if(length(fClustAnnotations) > 1 & max(cwCLEANscore.all) > 0) {
						sigLevels <- c(1, 3, 5, 10, 15, 20, 50, 100, 150, 200, 250, 299)
						newCdt<-insertCdt(cdtFile=paste(file, "cdt", sep = "."), insertVector = "", tree=gtr,columnName="", newCdtFile=NULL) #insert blank column
						for(sigLevel in sigLevels[sigLevels < max(cwCLEANscore.all)]) {
							newCdt<-insertCdt(cdtFile=paste(file, "cdt", sep = "."), insertVector=cwCLEANscore.all-sigLevel, 
								tree=gtr,columnName=paste("Overall CLEANscore-", sigLevel, sep = ""), newCdtFile=NULL)
						}
					}
				}
				r2fni(gtr, clustCategories = fClustAnnotations, file=paste(file, "fni", sep = "."))
			}
		}
	}
	if(callTreeView) call.treeview(paste(file,"cdt",sep ="."))
	if(saveDataObjects) { 
		gimmOut <- NULL
		gimmOut$clustData <- cdt
		gimmOut$hGClustData <- gtr
		gimmOut$hSClustData <- atr
		save(gimmOut, fClustAnnotations, file = paste(file,"RData",sep ="."))
	}
	invisible(list(data = cdt, rclust = gtr, cclust = atr, fClustAnnotations= fClustAnnotations))
}

`insertCdt` <-
function(cdtFile, insertVector,tree=NULL,columnName="FunctionalClustering",newCdtFile=NULL){
	if(length(tree)!=0) insertVector<-insertVector[tree$order]
	cdtData<-read.table(file=cdtFile,header = TRUE, sep = "\t", quote = "", stringsAsFactors = FALSE, check.names=FALSE)
	if(length(insertVector) == 1) {
		if(insertVector == "") cdtData <- cbind(cdtData, "")
	} else {
		i<-1
		while(length(grep("GENE",cdtData[i,1]))==0) {insertVector<-c(1, insertVector); i<-i+1}
		cdtData$FunctionalClustering<-insertVector
		if(columnName!="FunctionalClustering") names(cdtData)[dim(cdtData)[2]]<-columnName
	}
	if(length(newCdtFile)!=0) write.table(cdtData,file=newCdtFile,sep="\t",row.names=FALSE,col.names=TRUE,quote=FALSE)
	else write.table(cdtData,file=cdtFile,sep="\t",row.names=FALSE,col.names=TRUE,quote=FALSE)
	invisible(cdtData)
}

`geneSigInClustering` <-
function(tree,allGenes,CategoryID2GeneID,refGenes = NULL,maxSize=1000,minSize=10,maxNumOfClusters=NULL, minGenesInCategory=10,maxGenesInCategory=1000,minSigsInCategory=2,verbose=TRUE,inBkg=TRUE, sigFDR = 0.1){
	
	allClusters<-getAllClusters(tree=tree,maxSize=maxSize,minSize=minSize,clusterList=NULL, k=maxNumOfClusters)
	if(verbose) cat("Number of Clusters\n",length(allClusters),"\n")
	if(is.null(refGenes)) refGenes<-unique(allGenes)
	refCategories<-initializeCategories(CategoryID2GeneID, AllGeneIDs=refGenes, minGenesInCategory = minGenesInCategory, 
		maxGenesInCategory = maxGenesInCategory, inBkg = inBkg, verbose=verbose)

	geneMatrixSigs<-matrix(1,length(allGenes),length(allClusters))
	geneMatrixORs<-matrix(0,length(allGenes),length(allClusters))
	sigCategories<-NULL
	
	for(i in 1:length(allClusters)){
		if(verbose) cat("\n\nCluster ", i, " of ", length(allClusters), "\n\n")
		sigcategories<-significantCategories(unique(allGenes[allClusters[[i]]]),refCategories=refCategories, verbose = verbose)
		if(verbose) print(sigcategories$categories[1:10,])
		if(verbose) print(allClusters[[i]])
		if(length(sigcategories$categories)>0) {
			geneMatrixSigs[as.integer(allClusters[[i]]), i]<-sigcategories$categories[1,"FisherFDR"]
			geneMatrixORs[as.integer(allClusters[[i]]), i]<-max(sigcategories$categories[1,"logOR"])
		}
		sigCategories<-c(sigCategories,list(sigcategories$categories[sigcategories$categories[,"FisherFDR"]<sigFDR,]))
	}
	minFDR<- -log10(apply(geneMatrixSigs,1,min))
	maxOR<-apply(geneMatrixORs,1,max)
	list(minFDR=minFDR,maxOR=maxOR,geneMatrixSigs=geneMatrixSigs,geneMatrixORs=geneMatrixORs,allClusters=allClusters,sigCategories=sigCategories,refCategories=refCategories)
}

`r2fni` <-
function(hr, file = "cluster.fni", clustCategories = NULL, dec = ".") {
	get.genes <- function(merge,component) {
		#recursive version deprecated
		#if(component > 0) {
		#	c(get.genes(merge,merge[component,2]), get.genes(merge,merge[component,1]))
		#}  
		#else -component
	    toDoList <- component   
		doneList <- NULL
		while(length(toDoList)>0) {
			if(toDoList[1] > 0) {
				toDoList <- c(merge[toDoList[1],], toDoList[-1])
			} else {
				doneList <- c(-toDoList[1], doneList)
				toDoList <- toDoList[-1]
			}
		}
		doneList
	}

	CategoryCols <- c("nGenesInCategory","nAllGenesInCategory","FisherFDR", "logOR")
	fni <- NULL
	if(!is.null(clustCategories)) {
		fni <- rbind(fni, c("NodeID","CategoryType", "CategoryID", "CategoryDescription", CategoryCols))
		emptyCols <- rep("", length(CategoryCols)+ 2)
		i <- 1
		while(i <= dim(hr$merge)[1]) {
			NodeID <- paste("NODE", i, "X", sep = "")
			genes <- get.genes(hr$merge, i)
			index <- which(unlist(lapply(clustCategories[[1]]$allClusters, length)) == length(genes))
			if(length(index) > 0) {
				cluster <- index[sapply(index, function(j) 
					setequal(clustCategories[[1]]$allClusters[[j]], genes))]
				if(length(cluster) > 0) {
					sigCategories <- NULL
					for(j in 1:length(clustCategories)) {
						type <- names(clustCategories)[j]
						if(!is.null(clustCategories[[j]]$sigCategories[[cluster]])) {
							if(dim(clustCategories[[j]]$sigCategories[[cluster]])[1] > 0) {
								ID <- as.character(clustCategories[[j]]$sigCategories[[cluster]][,1])
								#if(is.null(clustCategories[[j]]$CategoryID2Desc) | is.na(clustCategories[[j]]$CategoryID2Desc)) {
								if(length(clustCategories[[j]]$CategoryID2Desc) < 2) {
									ID <- cbind(ID, Description = "")
								} else {
									ID <- cbind(ID, Description = clustCategories[[j]]$CategoryID2Desc[match(ID, clustCategories[[j]]$CategoryID2Desc[,1]), 2])
								}
								sigCategories <- rbind(sigCategories, cbind(NodeID, type, ID, clustCategories[[j]]$sigCategories[[cluster]][,CategoryCols]))
							}
						}
					}	
					if(is.null(sigCategories)) {
						fni <- rbind(fni, c(NodeID, "cluster is not significantly enriched for any of the considered categories", emptyCols))
					} else {
						sigCategories <- sigCategories[order(sigCategories[, "FisherFDR"]),]
						sigCategories[,"NodeID"] <- as.character(sigCategories[,"NodeID"])
						sigCategories[,"type"] <- as.character(sigCategories[,"type"])
						sigCategories[,"ID"] <- as.character(sigCategories[,"ID"])
						sigCategories[,"Description"] <- as.character(sigCategories[,"Description"])
						sigCategories[,"nGenesInCategory"] <- as.character(sigCategories[,"nGenesInCategory"])
						sigCategories[,"nAllGenesInCategory"] <- as.character(sigCategories[,"nAllGenesInCategory"])
						sigCategories[,"FisherFDR"] <- format(sigCategories[,"FisherFDR"], digits = 3, scientific = TRUE)
						sigCategories[,"logOR"] <- format(sigCategories[,"logOR"], digits = 3)
						fni <- rbind(fni, as.matrix(sigCategories))
					}
				} else {
					fni <- rbind(fni, c(NodeID, "cluster was not found in functional annotation file", emptyCols))
				}
			} else {
				fni <- rbind(fni, c(NodeID, "cluster size is outside the range considered for functional annotation", emptyCols))
			}
			i <- i+1
		}
		write.table(fni, file = file, row.names = FALSE, col.names = FALSE, quote = FALSE, sep = "\t")
	}
}

`atr2r` <-
function(atrFile){
	if (!file.exists(atrFile)) {
		warning(paste("File not found: ", atrFile, ". Trying ", atrFile, ".atr", sep=""))
		atrFile <- paste(atrFile, "atr", sep = ".")
	}
	colc<-c("character","character","character","numeric")
	atr<-read.table(atrFile,colClasses=colc)
	height<-1-atr[,4]
	clusterNum<-dim(atr)[[1]]
	merge<-matrix(0,clusterNum,2)
	clusterSize<-integer(clusterNum)
	for(i in 1:clusterNum) {
		for( j in 1:2) {
			tempStr<-atr[i,(j+1)]
			positive<-substr(tempStr,1,4) == "NODE"
			id<-substr(tempStr,5,(nchar(tempStr)-1))
			if(positive) merge[i,j]<-as.integer(id)
			else  merge[i,j]<- -as.integer(id)
			if(merge[i,j] > 0) {
				clusterSize[i]<-clusterSize[i]+clusterSize[merge[i,j]]
			}else {
				clusterSize[i]<-clusterSize[i]+1
			}
		}
	}
	perm<-clusterNum
	allLeafs <- FALSE
	while(!allLeafs) {
		allLeafs <- all(perm < 0)
		if(!allLeafs) {
			index <- which(perm>=0)[1]
			newPerm <- as.vector(merge[perm[index], ])
			if(index > 1) newPerm <- c(perm[1:(index-1)], newPerm)
			if(index < length(perm)) newPerm <- c(newPerm, perm[(index+1):length(perm)])
			perm <- newPerm
		}
	}
	res <- list(merge=merge, height=height, order=-perm, labels = 1:length(perm), method = "average")
	class(res) <- "hclust"
	res
}

`r2gtr` <-
function (hr, file = "cluster.gtr", dec = ".") {
	height <- hr$height
	if (range(height)[1] >= 0 & range(height)[2] <= 1) {
	##if (substr(distance, 1, 1) == "p") {
		height <- 1 - height
	} else {
		height <- height + 1
		height <- height[1]/height
	}
	##height <- signif(height, digits = digits)
	n <- length(height)
	node <- 1:n
	node <- paste("NODE", node, "X", sep = "")
	merge1 <- hr$merge[, 1]
	merge11 <- paste("NODE", merge1, "X", sep = "")
	merge12 <- paste("GENE", -merge1, "X", sep = "")
	merge1[hr$merge[, 1] > 0] <- merge11[hr$merge[, 1] > 0]
	merge1[hr$merge[, 1] < 0] <- merge12[hr$merge[, 1] < 0]
	merge2 <- hr$merge[, 2]
	merge11 <- paste("NODE", merge2, "X", sep = "")
	merge12 <- paste("GENE", -merge2, "X", sep = "")
	merge2[hr$merge[, 2] > 0] <- merge11[hr$merge[, 2] > 0]
	merge2[hr$merge[, 2] < 0] <- merge12[hr$merge[, 2] < 0]
	data <- data.frame(cbind(node, merge1, merge2))
	data <- cbind(data, height)
	write.table(data, file = file, row.name = FALSE, col.names = FALSE,
		quote = FALSE, sep = "\t", dec = dec)
}

`getFunctionalCategories` <-
function(functionalCategories, species=c("Hs", "Rn", "Mm")) {
	if(missing(species)|is.null(species)) {
		species <- "Hs"
		warning("Argument `species` should be one of `Hs`, `Mm`, `Rn`). Using the default `Hs`.")
	}
	species <- tryCatch(match.arg(species), 
		error = function(e) {warning("Argument `species` should be one of `Hs`, `Mm`, `Rn`). Using the default `Hs`.");"Hs"})
	require(AnnotationDbi)
    fCategories <- list()
    for(i in 1:length(functionalCategories)) {
        if(toupper(functionalCategories[i]) == "GO") {
            require("GO.db", character.only = TRUE)
            require(paste("org", species, "eg.db", sep = "."), character.only = TRUE)
            GOID2GeneID <- as.list(get(paste("org", species, "egGO2ALLEGS", sep = ".")))
            k <- keys(get("GOTERM"))
            l <- toTable(get("GOTERM"))
            GOID2Desc <- cbind(GOID = k, GOTerm = l[match(k, l[,1]), "Term"])
            fCategories <- c(fCategories, list(GO = list(GOID2GeneID, GOID2Desc)))
        } else if(toupper(functionalCategories[i]) == "KEGG") {
            require("KEGG.db", character.only = TRUE)
            KEGGID2GeneID <- as.list(get("KEGGPATHID2EXTID"))
            spec <- unique(substr(names(KEGGID2GeneID), 1, 3))
            l <- as.list(get("KEGGPATHID2NAME"))
            KEGGID2Desc <- cbind(ID = paste(rep(spec, each = length(l)), rep(names(l), times = length(spec)), sep = ""),
                Name = rep(unlist(l), times = length(spec)))
            fCategories <- c(fCategories, list(KEGG = list(KEGGID2GeneID, KEGGID2Desc)))
        } else {
			require(paste("CLEAN", species, sep = "."), character.only = TRUE)
            e1 <- new.env()
            data(list = paste(functionalCategories[i], species, sep = "."), envir = e1)
            if(length(ls(e1)) > 0) {
                fCategories <- c(fCategories, list(get(paste(functionalCategories[i], species, sep = "."), envir = e1)))
                names(fCategories)[length(fCategories)] <- functionalCategories[i]
            }
        }
    }
    fCategories
}

`geneSigInClustering_nullDistr` <-
function(allClusters,allGenes,CategoryID2GeneID,refCategories = NULL,minGenesInCategory=10,maxGenesInCategory=1000,verbose=TRUE,inBkg=FALSE, sigFDR = 0.1){
	
	if(verbose) cat("Number of Clusters\n",length(allClusters),"\n")
	if(is.null(refCategories)) {
		refGenes<-unique(allGenes)
		refCategories<-initializeCategories(CategoryID2GeneID, AllGeneIDs=refGenes,verbose=FALSE, 
			minGenesInCategory=minGenesInCategory, maxGenesInCategory=maxGenesInCategory, inBkg = inBkg)
	}	
	geneMatrixSigs<-matrix(1,length(allGenes),length(allClusters))
	#geneMatrixORs<-matrix(0,length(allGenes),length(allClusters))
	sigCategories<-NULL
	if (verbose) cat("\n")
	for(i in 1:length(allClusters)){
		if(verbose) cat("Cluster ", i, " of ", length(allClusters), "\n")
		sigcategories<-significantCategories(unique(allGenes[allClusters[[i]]]), refCategories=refCategories, verbose = FALSE)
		#if(verbose) print(sigcategories$categories[1:10,])
		#if(verbose) print(allClusters[[i]])
		if(length(sigcategories$categories)>0) {
			geneMatrixSigs[as.integer(allClusters[[i]]), i]<-sigcategories$categories[1,"FisherFDR"]
			#geneMatrixORs[as.integer(allClusters[[i]]), i]<-max(sigcategories$categories[1,"logOR"])
		}
		sigCategories<-c(sigCategories,list(sigcategories$categories[sigcategories$categories[,"FisherFDR"]<sigFDR,]))
	}
	#minFDR<- -log10(apply(geneMatrixSigs,1,min))
	#maxOR<-apply(geneMatrixORs,1,max)
	
	geneMatrixSig <- matrix(1, dim(geneMatrixSigs)[1], dim(geneMatrixSigs)[2])
	for(i in 1:length(sigCategories)) {
		clusterGenes <- refCategories$AllGeneIDs[allClusters[[i]]]
		if(!is.null(sigCategories[[i]])) {
			if(dim(sigCategories[[i]])[1] > 0) {
				for(j in 1:(dim(sigCategories[[i]])[1])) {
					categoryGenes <- unique(refCategories$CategoriesWithGenes[[as.character(sigCategories[[i]][j,1])]])
					index <- intersect(allClusters[[i]][!is.na(match(clusterGenes, categoryGenes))], which(geneMatrixSig[, i] > sigCategories[[i]][j,3]))
					geneMatrixSig[index, i] <- sigCategories[[i]][j,3]
				}
			}
		}
	}
	#list(minFDR_nullDistr=minFDR,maxOR_nullDistr=maxOR)#,geneMatrixSigs=geneMatrixSigs,geneMatrixORs=geneMatrixORs,allClusters=allClusters,sigCategories=sigCategories)
	-log10(apply(geneMatrixSig, 1, min))
}

`r2atr` <-
function (hc, file = "cluster.atr", dec = ".") {
	height <- hc$height
	if (range(height)[1] >= 0 & range(height)[2] <= 1) {
		height <- 1 - height
	} else {
		height <- height + 1
		height <- height[1]/height
	}
	##height <- signif(height, digits = digits)
	n <- length(height)
	node <- 1:n
	node <- paste("NODE", node, "X", sep = "")
	merge1 <- hc$merge[, 1]
	merge11 <- paste("NODE", merge1, "X", sep = "")
	merge12 <- paste("ARRY", -merge1, "X", sep = "")
	merge1[hc$merge[, 1] > 0] <- merge11[hc$merge[, 1] > 0]
	merge1[hc$merge[, 1] < 0] <- merge12[hc$merge[, 1] < 0]
	merge2 <- hc$merge[, 2]
	merge11 <- paste("NODE", merge2, "X", sep = "")
	merge12 <- paste("ARRY", -merge2, "X", sep = "")
	merge2[hc$merge[, 2] > 0] <- merge11[hc$merge[, 2] > 0]
	merge2[hc$merge[, 2] < 0] <- merge12[hc$merge[, 2] < 0]
	data <- data.frame(cbind(node, merge1, merge2))
	data <- cbind(data, height)
	if (dec == ",") {
		data <- apply(data, 2, function(u) {chartr(".", ",", u)})
		data[data == "NA"] <- NA
	}
	write.table(data, file = file, row.name = FALSE, col.names = FALSE, quote = FALSE, sep = "\t")
}

`plotCLEANscore` <- 
function(fClustAnnotations, fCategoryName = "GO", maxCLEANscore = NULL, add = FALSE, ...) 
{
	index <- grep(fCategoryName, names(fClustAnnotations))
	if(is.null(maxCLEANscore)) { 
		mF <- round(max(fClustAnnotations[[index]]$CLEANscore)) 
	} else { 
		mF <- maxCLEANscore
	}
	if(add) {
		lines(1:mF, sapply(1:mF, function(x) sum(fClustAnnotations[[index]]$CLEANscore > x, na.rm = TRUE)), ...)
	} else {
		plot(1:mF, sapply(1:mF, function(x) sum(fClustAnnotations[[index]]$CLEANscore > x, na.rm = TRUE)), log = "y", xlab = "CLEAN score",
			ylab = "# genes with CLEAN score <= threshold", type = "l", ...)
	}
}

`getAllClusters` <-
function(tree, maxSize=1000, minSize=10, clusterList=NULL, k=NULL) {
#recursive version of this function
#deprecated because unstable with some clustering algorithms
#	pos<-c(F,T)
#	for(side in pos) {
#		subTree<-getBinarySubTree(tree,side)
#		genes<-subTree$labels
#		if(length(genes) >= minSize && length(genes)<=maxSize) {
#			clusterList[[length(clusterList)+1]]<-genes
#		}
#		if(length(genes) >= minSize) {
#			clusterList<-getAllClusters(subTree,maxSize,minSize,clusterList)
#		}
#	}
#	clusterList
	if(missing(k) | is.null(k)) k <- Inf
	else { 
		if(k < 0) k <- 0
		if(nrow(tree$merge) < maxSize) k <- k + 1
	}
	treeList <- list(list(node = tree, splitMore = TRUE, isLeaf = FALSE))
	if(is.null(tree$labels)) warning("tree does not have labels, function may not generate any meaningful clusters.")
	if(length(tree$labels) <= maxSize & length(tree$labels) >= minSize) treeList[[1]]$isLeaf = TRUE
	if(minSize < 2) {
		warning(paste("minimum cluster size", minSize, "too small, set to 2."))
		minSize <- 2 
	}
	f <- function(treeListElement, maxSize, minSize) {
		treeList <- as.list(NULL)
		if(treeListElement$splitMore) {
			pos<-c(FALSE, TRUE)
			subTrees <- list(getBinarySubTree(treeListElement$node, FALSE),
				getBinarySubTree(treeListElement$node, TRUE))
			if(max(subTrees[[1]]$height) < max(subTrees[[2]]$height))
				subTrees <- subTrees[2:1]
			for(side in pos) {
				newTree <- NULL
				#subTree<-getBinarySubTree(treeListElement$node,side)
				subTree <- subTrees[[side+1]]
				subTree$call <- "getBinarySubTree(treeListElement$node,side)"
				newTree$node <- subTree
				genes<-subTree$labels
				if(length(genes) >= minSize) {
					newTree$splitMore <- TRUE
					if(length(genes)<=maxSize) {
						newTree$isLeaf <- TRUE
					} else {
						newTree$isLeaf <- FALSE
					}
					treeList <- c(treeList,list(newTree))
				} 
			}
		}
		treeList
	}
	allLeaves <- FALSE
	while(!allLeaves) {
		allLeaves <- TRUE
		trees <- NULL
		toBeRemoved <- NULL
		for(i in 1:length(treeList)) {
			newTrees <- NULL
			if(treeList[[i]]$splitMore) {
				newTrees <- f(treeList[[i]], maxSize, minSize)
				if(!treeList[[i]]$isLeaf) {
					toBeRemoved <- c(toBeRemoved, i)
				} else {
					treeList[[i]]$splitMore <- FALSE
				}
			}
			if(length(newTrees) > 0) {
				allLeaves <- FALSE
				trees <- c(trees, newTrees)
			}
		}
		if(!is.null(toBeRemoved)) treeList <- treeList[-toBeRemoved]
		treeList <- c(treeList, trees)
		if(length(treeList) > k) allLeaves <- TRUE
	}
	res <- lapply(treeList, function(subTree) subTree$node$labels)
	res[1:min(k, length(res))]
}

`cdt2r` <-
function(cdtFile) {
	if (!file.exists(cdtFile)) {
		warning(paste("File not found: ", cdtFile, ". Trying ", cdtFile, ".cdt", sep=""))
		cdtFile <- paste(cdtFile, "cdt", sep = ".")
	}
	cdt <- read.table(cdtFile, sep = "\t", stringsAsFactors=FALSE, header = TRUE, quote = "")
	data.start.row <- which(cdt[,1] == "EWEIGHT") + 1
	data.start.col <- which(colnames(cdt) == "GWEIGHT") + 1
	if(length(data.start.row) < 1) { #there was no "EWEIGHT" row
		data.start.row <- 1
	}
	if(length(data.start.col) < 1) { #there was no "GWEIGHT" column
		if(colnames(cdt)[1] == "GID") data.start.col <- 4
		else data.start.col <- 3
	}
	if(colnames(cdt)[1] == "GID"){
		ID.col <- 2
		NAME.col <- 3
	} else {
		ID.col <- 1
		NAME.col <- 2
	}
	data.last.row <- dim(cdt)[1]
	data.last.col <- dim(cdt)[2]
	cdt <- cdt[data.start.row:data.last.row, c(ID.col,NAME.col,data.start.col:data.last.col)]
	for(i in 3:dim(cdt)[2]) cdt[, i]<-as.numeric(as.character(cdt[, i]))
	cdt
}

`LRpath` <-
function(sigvals, geneids, min.g=10, max.g=NA, sig.cutoff=0.05,
	database="GO", functionalCategories=NULL, odds.min.max=c(0.001,0.5), species="Hs") {

## prepare database/functionalCategories, etc.
if(!(is.factor(geneids) | is.numeric(geneids) | is.character(geneids))) {
	warning("Parameter `geneids` should be a character or numeric vector, or a factor.")
}
if(is.factor(geneids)) {
	geneids <- as.character(geneids)
	warning("Converted geneids from factor to character.")
}
if(!missing(database)) {
	legacy <- TRUE
    warning("Argument `database` deprecated.  Please use `functionalCategories` instead.")
	if(missing(functionalCategories)) {
		functionalCategories <- database
	}
} else {
	legacy <- FALSE
}
if (is.null(functionalCategories)) {
	functionalCategories <- "GO"
}
if(!is.list(functionalCategories)) functionalCategories <- as.list(unique(functionalCategories))
CategoryID2GeneID <- list()
CategoryID2Desc <- list()
runLRpath <- rep(TRUE, length(functionalCategories))
for(i in 1:length(functionalCategories)) {
	if(is.character(functionalCategories[[i]])) {
	    if(substr(functionalCategories[[i]],nchar(functionalCategories[[i]])-4,nchar(functionalCategories[[i]])) == "RData") {
		    e1 <- new.env()
			load(file = functionalCategories[[i]], envir = e1)
			if(length(ls(envir = e1, pattern = "2[G,g][E,e][N,n][E,e]")) > 0) {
			    l <- list(get(ls(envir = e1, pattern = "2[G,g][E,e][N,n][E,e]")[1], envir = e1))
				names(l) <- names(functionalCategories)[i]
				if(is.null(names(l))) names(l) <- substr(functionalCategories[[i]], 1, nchar(functionalCategories[[i]])-6)
				CategoryID2GeneID <- c(CategoryID2GeneID, l)
			} else {
				runLRpath[i] <- FALSE
			    CategoryID2GeneID <- c(CategoryID2GeneID, list(NA))
				warning(paste("No functional categories found in file", functionalCategories[[i]], "-  No functional clustering annotation generated."))
			}
			if(length(ls(envir = e1, pattern = "2[D,d][E,e][S,s][C,c]")) > 0) {
			    l <- list(get(ls(envir = e1, pattern = "2[D,d][E,e][S,s][C,c]")[1], envir = e1))
				names(l) <- names(functionalCategories)[i]
				if(is.null(names(l))) names(l) <- substr(functionalCategories[[i]], 1, nchar(functionalCategories[[i]])-6)
				CategoryID2Desc <- c(CategoryID2Desc, l)
			} else CategoryID2Desc <- c(CategoryID2Desc, list(NA))
		} else {
			species <- paste(toupper(substr(species, 1, 1)), substr(species, 2, 2), sep = "")
			l1 <- getFunctionalCategories(functionalCategories[[i]], species)
			if(length(l1) > 0) {
			    l <- l1[[1]][1]
				names(l) <- functionalCategories[[i]]
				CategoryID2GeneID <- c(CategoryID2GeneID, l)
				if(length(l1[[1]]) > 1) {
				    l <- l1[[1]][2]
					names(l) <- functionalCategories[[i]]
					CategoryID2Desc <- c(CategoryID2Desc, l)
				} else CategoryID2Desc <- c(CategoryID2Desc, list(NA))
			} else {
				runLRpath[i] <- FALSE
			    CategoryID2GeneID <- c(CategoryID2GeneID, list(NA))
				CategoryID2Desc <- c(CategoryID2Desc, list(NA))
				warning(paste("functional categories", functionalCategories[[i]], "not found.  No functional clustering annotation generated."))
			}
		}
	} else {   #functionalCategories[[i]] is a list
		l <- functionalCategories[[i]][1]
		names(l) <- names(functionalCategories)[i]
		CategoryID2GeneID <- c(CategoryID2GeneID, l)
		if(length(functionalCategories[[i]]) > 1) {
		    l <- functionalCategories[[i]][2]
			names(l) <- names(functionalCategories)[i]
			CategoryID2Desc <- c(CategoryID2Desc, l)
		} 
		else CategoryID2Desc <- c(CategoryID2Desc, list(NA))
	}
} 
## run LRpath
if(any(runLRpath)) {
	LRresults <- list()
	for(ii in 1:length(runLRpath)) {
		if(runLRpath[ii]) {
			
			cat(paste("Analyzing", names(CategoryID2GeneID)[ii], "categories"))

			xx <- CategoryID2GeneID[[ii]]
			#xx <- lapply(xx, unique)
			ENTREZ.in.DB <- unique(unlist(xx))
			if(length(intersect(ENTREZ.in.DB, unique(geneids))) < min.g) 
				warning(paste("min.g=", min.g, " is larger than number of gene IDs overlapping with ", names(CategoryID2GeneID)[ii], ". Please consider lower min.g.", sep=""))

			sigvals[sigvals==0]<- 10^(-15)
			geneids2<-geneids[!is.na(geneids)&!is.na(sigvals)&geneids %in% ENTREZ.in.DB]
			sigvals2<-sigvals[!is.na(geneids)&!is.na(sigvals)&geneids %in% ENTREZ.in.DB]

			uniqids<-unique(geneids2)
			numuniq<-length(uniqids)
			LOR.mult<-log(odds.min.max[2])-log(odds.min.max[1])

			################ Average -log(p-values) for duplicate locusids
			nlp<-(-1)*log(sigvals2)
			newp<-NA
			for (i in (1:numuniq)){
				current<-nlp[geneids2==uniqids[i]]  #Get all values for i-th geneid
				#numrep<-length(current)
				newp[i]<-mean(current)
			}
			#plot(c(1,2,3),c(1,2,3))
			### Limit testing to those categories with at least min.g genes TOTAL
			catsizes<-sapply(xx,length)
			yy<-xx[catsizes>=min.g]
			ncats<-length(yy)

			#siggenes <- uniqids[exp(-newp)<0.05]  ##  If averaged p-value < 0.05
			siggenes <- uniqids[exp(-newp)<sig.cutoff]

			######################################################################
			###  Test all categories to which at least min ANALYZED genes belong

			LRcoeff<-NA; LRpval<-NA; cattots<-NA; yyind<-NA; GOnums<-NA
			catsigIDs<-NA
			ind<-0
			if (is.na(max.g)) {
				max.g<-99999
			}
			for (i in (1:ncats)){
				catgenes<-as.character(yy[[i]])
				catgenes<-unique(catgenes)
				catpoprows<-match(catgenes, uniqids)
				catpoprows<-catpoprows[!is.na(catpoprows)]
					cattot<-length(catpoprows)	#Number of analyzed genes in category
				if (cattot>=min.g&cattot<=max.g) {
					ind<-ind+1
					cat<-rep(0,numuniq)
					cat[catpoprows]<- 1
					forLR<- as.data.frame(cbind(cat,newp))
						names(forLR)<-c("cat","nlogp")

					withCallingHandlers(
						glm.lrGO <- glm(cat ~ nlogp, family=binomial(link="logit"),forLR),
						warning = function(w) {
							if(length(grep("fitted probabilities numerically 0 or 1 occurred", as.character(w)))==1)
							    warning("fitted probabilities numerically 0 or 1 occurred: functional category appears to induce linear separation of p-values.")})
					lrGO<-summary(glm.lrGO)
					###########  Extract p-value and coefficient
					LRcoeff[ind]<-lrGO$coefficients["nlogp","Estimate"]
					LRpval[ind]<-lrGO$coefficients["nlogp","Pr(>|z|)"]
					cattots[ind]<-cattot
					#yyind[ind]<-i
					GOnums[ind]<-names(yy[i])

					catsig.IDlist<-intersect(siggenes,catgenes)
					catsigIDs[ind]<-paste(catsig.IDlist[order(catsig.IDlist)],collapse=", ")
   				}
				if (i%%100 == 0) {
					cat(".")
				}
			}
			cat("\n")
			odds.ratio<-exp(LOR.mult*LRcoeff)
			BenjFDR<-p.adjust(LRpval,"BH")
			kterms <- CategoryID2Desc[[ii]][,2]
			k.ids <- CategoryID2Desc[[ii]][,1]
			keggrows<- match(GOnums,k.ids)
			kegg.annot<-kterms[keggrows]
			if(is.na(GOnums)) {
				warning(paste("No results found for ", names(CategoryID2GeneID)[ii], ".", sep=""))
				LRres <- NA
			} else {
				LRres <-cbind(GOnums,kegg.annot,cattots,LRcoeff, odds.ratio,as.data.frame(LRpval),BenjFDR,catsigIDs)
				names(LRres)<- c("category.ID", "category.description", "n.genes", "coeff", "odds.ratio", "p.value", "FDR", "sig.genes")
			}
			LRresults <- c(LRresults, list(LRres))
			names(LRresults)[length(LRresults)] <- names(CategoryID2GeneID)[ii]
		}
	}
}
if(length(LRresults) == 1 & legacy) LRresults <- LRresults[[1]]
invisible(LRresults)
} #End function LRpath

`pruneMinFDR` <-
function(clustCategories) {
	clusters <- clustCategories$allClusters
	clustVals <- unlist(lapply(apply(clustCategories$geneMatrixSigs, 2, function(x) unique(x[x < 1])), 
		function(x) if(length(x) < 1) 1 else x))
	clustSize <- unlist(lapply(clusters, length))
	geneMatrixSig <- clustCategories$geneMatrixSigs
	toDo <- (1:length(clusters))[order(clustVals)]
	while(length(toDo) > 0 & clustVals[toDo[1]] < 1) {
		cluster <- toDo[1]
		index <- toDo[-1]
		if(length(index) > 0) {
			index <- index[sapply(index, function(j) length(intersect(clusters[[j]], clusters[[cluster]])) > 0)]
			toDo <- setdiff(toDo, index)
			geneMatrixSig[,index] <- 1
		}
		toDo <- toDo[-1]
	}
	-log10(apply(geneMatrixSig,1, min))
}

`gtr2r` <-
function(gtrFile){
	if (!file.exists(gtrFile)) {
		warning(paste("File not found: ", gtrFile, ". Trying ", gtrFile, ".gtr", sep=""))
		gtrFile <- paste(gtrFile, "gtr", sep = ".")
	}
	colc<-c("character","character","character","numeric")
	gtr<-read.table(gtrFile,colClasses=colc)
	height<-1-gtr[,4]
	clusterNum<-dim(gtr)[[1]]
	merge<-matrix(0,clusterNum,2)
	clusterSize<-integer(clusterNum)
	for(i in 1:clusterNum) {
		for( j in 1:2) {
			tempStr<-gtr[i,(j+1)]
			positive<-substr(tempStr,1,4) == "NODE"
			id<-substr(tempStr,5,(nchar(tempStr)-1))
			if(positive) merge[i,j]<-as.integer(id)
			else  merge[i,j]<- -as.integer(id)
			if(merge[i,j] > 0) {
				clusterSize[i]<-clusterSize[i]+clusterSize[merge[i,j]]
			}else {
				clusterSize[i]<-clusterSize[i]+1
			}
		}
	}
	perm<-clusterNum
	allLeafs <- FALSE
	while(!allLeafs) {
		allLeafs <- all(perm < 0)
		if(!allLeafs) {
			index <- which(perm>=0)[1]
			newPerm <- as.vector(merge[perm[index], ])
			if(index > 1) newPerm <- c(perm[1:(index-1)], newPerm)
			if(index < length(perm)) newPerm <- c(newPerm, perm[(index+1):length(perm)])
			perm <- newPerm
		}
	}
	res <- list(merge=merge, height=height, order=-perm, labels = 1:length(perm), method = "average")
	class(res) <- "hclust"
	res
}

\name{call.treeview}
\alias{call.treeview}
\title{Function to call the standalone fTreeView Java application}
\description{
    This function calls fTreeview, a Java appplication to display the heatmap, gene clustering, sample clustering, and functional annotation files generated with the CLEAN package.
}
\usage{
call.treeview(cdtFile = "cluster.cdt", treeViewPath = .fTreeViewPath, wait = FALSE)
}
\arguments{
  \item{cdtFile}{A file in cdt format.  The .cdt file name extension may be omitted}
  \item{treeViewPath}{Path where the treeview jar file is located}
  \item{wait}{Parameter to the system() function}
}
\author{Johannes Freudenberg}
\seealso{\code{\link{funcClustAnnot}}, \code{\link{system}}, \code{\link{r2cdt}}}
\examples{
## not run
# data(gimmOut)
# funcClustAnnot(gimmOut, file = "cluster")
# call.treeview("cluster.cdt")
}
\keyword{ IO }
\keyword{ cluster }

\name{nonHierarchicalClustering}
\alias{nonHierarchicalClustering}
\title{Convert a non-hierarchical clustering into hierarchical tree-structure }
\description{
coming soon.
}
\usage{
nonHierarchicalClustering(clustering, data = NULL, k = NULL, nRepeats = 1, ...)
}
\arguments{
  \item{clustering}{A vector assigning genes or samples to clusters, or a function}
  \item{data}{The data to be clustered if clustering is a function.}
  \item{k}{The number of clusters to be generated}
  \item{nRepeats}{The number of runs to be averaged.}
  \item{\dots}{Additional parameters to be passed to clustering}
}
\details{
coming soon.
}
\value{
a dist object.
}
\references{coming soon. }
\author{Johannes Freudenberg }
\note{coming soon.
}
\seealso{ \code{\link{funcClustAnnot}} }
\examples{
data(gimmOut)
require(CLEAN.Rn)
d <- nonHierarchicalClustering(function(m, k, ...) kmeans(m, k, ...)$cluster,
    gimmOut$clustData[,-(1:2)], k = 2:4, nstart = 10)
trt <- sapply(colnames(gimmOut$clustData)[-(1:2)], function(str) strsplit(str, split = "_")[[1]][1])
#not run
#generateTreeViewFiles(gimmOut, rclust = d, cclust = NA, verbose = FALSE, functionalCategories=c("geneRIFs",
#	"CpGislands", "GO", "KEGG"), species = "Rn", callTreeView = TRUE, sampleDesc = trt)
generateTreeViewFiles(gimmOut, rclust = d, cclust = NA, verbose = FALSE, functionalCategories=c("geneRIFs",
	"CpGislands", "GO", "KEGG"), species = "Rn", callTreeView = FALSE, sampleDesc = trt, maxNumOfClusters=2)

# all possible cluster numbers (k)
d <- nonHierarchicalClustering(function(m, k, ...) kmeans(m, k, ...)$cluster, 
	gimmOut$clustData[,-(1:2)], nstart = 10)
# k = 4
d <- nonHierarchicalClustering(function(m, k, ...) kmeans(m, k, ...)$cluster, 
	gimmOut$clustData[,-(1:2)], 4, nstart = 10)
#sample clustering
d2 <- nonHierarchicalClustering(function(m, k, ...) kmeans(m, k, ...)$cluster, t(gimmOut$clustData[,-(1:2)]), 9, nstart = 10) #sample clustering

##not run
#generateTreeViewFiles(gimmOut$clustData, d, d2, callTreeView=TRUE, species = "Rn")
generateTreeViewFiles(gimmOut$clustData, d, d2, callTreeView=FALSE, species = "Rn")
}
\keyword{cluster }

\name{cdt2r}
\alias{cdt2r}
\alias{atr2r}
\alias{gtr2r}
\title{Functions to import files in TreeView format into R.}
\description{
  cdt2r() imports a cdt file and converts it to a dataframe where rows represent genes and columns represent samples.  The first column of the dataframe contains the gene identifiers and the second column contains gene names or descriptions.  Column names represent sample names.
}
\usage{
cdt2r(cdtFile)
gtr2r(gtrFile)
atr2r(atrFile)
}
\arguments{
  \item{cdtFile}{A cdt file}
  \item{gtrFile}{A gtr file}
  \item{atrFile}{An atr file}
}
\details{
  cdt2r() reads a tab-delimited file in generalized cdt format where the first row contains sample names, followed by additional optional rows.  The first two or three columns contain gene IDs and descriptions, and optional additional columns, followed by gene expression data.  The function returns a dataframe with gene IDs and descriptions in the first two columns, gene expression data in the remaining columns, and column names representing samples. 
  gtr2r() and atr2r() read tree files representing the hierarchical gene tree or sample tree structure, respectively.  Both functions return an hclust object.
}
\value{
  cdt2r() returns a dataframe (see details)
  gtr2r() and atr2r() each return an hclust objects
}
\references{ coming soon }
\author{ Johannes Freudenberg, Xiangdong Liu, Mario Medvedovic }
\seealso{ \code{\link{funcClustAnnot}}, \code{\link{hclust}}, \code{\link{r2cdt}} }
\examples{
data(gimmOut)
generateTreeViewFiles(gimmOut$clustData, file="cluster") 
exprData <- cdt2r("cluster.cdt")
gclust <- gtr2r("cluster.gtr")
plot(as.dendrogram(gclust))
sclust <- atr2r("cluster.atr")
}
\keyword{ cluster }
\keyword{ IO }

\name{geneSigInClustering}
\alias{geneSigInClustering}
\alias{geneSigInList}
\alias{getAllClusters}
\alias{pruneMinFDR}
\alias{insertCdt}
\alias{initializeCategories}
\alias{significantCategories}
\alias{geneSigInClustering_nullDistr}
\title{ Auxiliary functions to funcClustAnnot and geneListEnrichment }
\description{
  These functions are called by the generateTreeViewFiles(), runCLEAN() and the geneListEnrichment() functions.
}
\usage{
}
\details{
}
\value{
}
\author{ Johannes Freudenberg, Xiangdong Liu, Mario Medvedovic}
\note{

}
\seealso{ \code{\link{runCLEAN}}}
\examples{
}
\keyword{cluster}

\name{funcClustAnnot}
\alias{funcClustAnnot}
\alias{geneListEnrichment}
\alias{generateTreeViewFiles}
\alias{runCLEAN}
\title{Wrapper function to perform functional Clustering Enrichment Analysis (CLEAN)}
\description{
This function takes a gene expression data set, hierarchical clusterings of genes and samples, and a list of gene sets representing functional categories.  It performs hierarchical clustering (if not  provided) and performs the Clustering Enrichment Analysis.  Finally, it generates files to display data, clustering, and functional annotation using tools such as the Java-based fTreeView.
}
\usage{
funcClustAnnot(data = NULL, rclust = NULL, cclust = NULL, funcCategories = NULL, fClustAnnotations = NULL, bkgList = NULL, file = "cluster", maxSize = 1000, minSize = 10, minGenesInCategory = 10, maxGenesInCategory = 1000, minSigsInCategory = 2, inBkg = TRUE, sigFDR = 0.1, addCLEANscore2cdt = TRUE, species = NULL, estimateNullDistribution = FALSE, atr.distance = "euc", gtr.distance = "euc", dec = ".", digits = 5, verbose = TRUE, saveDataObjects = FALSE, sampleDesc = NULL, callTreeView = FALSE)
generateTreeViewFiles(data = NULL, rclust = NULL, cclust = NULL, functionalCategories = NULL, fClustAnnotations = NULL, bkgList = NULL, file = "cluster", maxSize = 1000, minSize = 10, maxNumOfClusters=NULL, minGenesInCategory = 10, maxGenesInCategory = 1000, inBkg = TRUE, sigFDR = 0.1, addCLEANscore2cdt = TRUE, species = NULL, estimateNullDistribution = FALSE, dec = ".", verbose = TRUE, saveDataObjects = FALSE, sampleDesc = NULL, callTreeView = FALSE)
geneListEnrichment(geneList, allGenes, functionalCategories = NULL, species = NULL, minGenesInCategory=10, maxGenesInCategory=1000, inBkg=TRUE, sigFDR = 0.1, verbose=TRUE)
runCLEAN(data = NULL, rclust = NULL, functionalCategories = NULL, bkgList = NULL, file = "cluster", maxSize=1000, minSize=10, maxNumOfClusters=NULL, minGenesInCategory=10, maxGenesInCategory=1000, inBkg=TRUE, sigFDR = 0.1, species = NULL, estimateNullDistribution = FALSE, verbose=TRUE, saveDataObjects = FALSE)
}
\arguments{
  \item{data}{ Gene expression data set.}
  \item{geneList}{A gene list to be tested for enrichment of functional categories.}
  \item{rclust}{Gene clustering.}
  \item{cclust}{Sample clustering.}
  \item{functionalCategories}{A collection of gene sets, representing functional categories.}
  \item{funcCategories}{A collection of gene sets, representing functional categories.}
  \item{fClustAnnotations}{A list of Clustering Enrichment Analysis results.  If provided, CLEAN is not performed which considerably reduces computing time.}
  \item{allGenes}{A list of genes to be used as background for gene list enrichment analysis.}
  \item{bkgList}{A list of genes to be used as background for CLEAN.}
  \item{file}{Name of the file(s) (without extensions) to be generated.}
  \item{maxSize}{Maximum cluster size to be considered by CLEAN.}
  \item{minSize}{Minimum cluster size to be considered by CLEAN.}
  \item{maxNumOfClusters}{Maximum number of clusters to be considered by CLEAN.  If specified, the top `maxNumOfClusters` from the tree cutting function will be chosen}
  \item{minGenesInCategory}{Minimum number of all genes in the expression data set overlapping with a given functional category.}
  \item{maxGenesInCategory}{Maximum number of all genes in the expression data set overlapping with a given functional category.}
  \item{minSigsInCategory}{Minimum number of genes in a cluster overlapping with a functional category.}
  \item{inBkg}{ -- to be completed -- } 
  \item{sigFDR}{FDR cutoff for a functional category to be overrepresented in a cluster.}
  \item{addCLEANscore2cdt}{If TRUE one or more columns are added to the cdt file indicating the highest significance level observed for a cluster by CLEAN.}
  \item{species}{Two letter description of the species to be used to generate gene ontology categories (e.g. "Hs" for human, "Mm" for mouse). This parameter is used when funcCategories = "GO"}
  \item{estimateNullDistribution}{If TRUE an empirical estimate of the Null-distribution of the CLEAN score is computed.}
  \item{atr.distance}{The distance metric used by the sample clustering -- deprecated.}
  \item{gtr.distance}{The distance metric used by the gene clustering -- deprecated.}
  \item{dec}{The decimal character to be used when writing the treeview files.}
  \item{digits}{Number of significant digits to be used when writing the treeview files -- deprecated. }
  \item{verbose}{If TRUE lots of additional output will be generated.}
  \item{saveDataObjects}{If TRUE, data, clusterings, and CLEAN results will be saved to disc as with filename <file>.RData.}
  \item{sampleDesc}{A vector or factor describing the samples.  Samples with same description will be grouped together if cclust = NA.}
  \item{callTreeView}{If TRUE the Java application fTreeView is called to display the CLEAN results.}
}
\details{
coming soon.
}
\value{
  A list:
  \item{data}{A dataframe containing the gene expression data.}
  \item{rclust, cclust}{Hierarchical clusterings (hclust objects) of genes and samples, respectively.}
  \item{fClustAnnotations}{CLEAN results.}
}
\references{Coming soon.}
\author{Johannes Freudenberg, Xiangdong Liu, Mario Medvedovic.}
\note{
}
\seealso{\code{\link{hclust}}, \code{\link[gimmR:gimmR-package]{gimmR}}, \code{\link[GO:GO-package]{GO}}, \code{\link[KEGG:KEGG-package]{KEGG}}, \code{\link{r2cdt}}, \code{\link{call.treeview}}}
\examples{
data(gimmOut)
require(CLEAN.Rn)
res <- runCLEAN(gimmOut, species = "Rn")

generateTreeViewFiles(gimmOut, functionalCategories=getFunctionalCategories("geneRIFs", species = "Rn"))
#same as
generateTreeViewFiles(gimmOut, functionalCategories="geneRIFs", species = "Rn")

#multiple category types
generateTreeViewFiles(gimmOut, functionalCategories=c("geneRIFs", "CpGislands", "GO", "KEGG"), species = "Rn")

trt <- sapply(colnames(gimmOut$clustData)[-(1:2)], function(str) strsplit(str, split = "_")[[1]][1])
#not run
#generateTreeViewFiles(gimmOut, cclust = NA, verbose = FALSE, functionalCategories=c("geneRIFs",
#    "CpGislands", "GO", "KEGG"), species = "Rn", callTreeView = TRUE, sampleDesc = trt)
generateTreeViewFiles(gimmOut, cclust = NA, verbose = FALSE, functionalCategories=c("geneRIFs",
    "CpGislands", "GO", "KEGG"), species = "Rn", callTreeView = FALSE, sampleDesc = trt)

#geneList enrichment
geneList <- gimmOut$clustData[,1]
require(org.Rn.eg.db)
allGenes <- unique(keys(org.Rn.egSYMBOL)) #one should really use the list of
                                          #genes represented on the microarray instead
res <- geneListEnrichment(geneList, allGenes, functionalCategories = "GO",
	species = "Rn", sigFDR = 0.01, maxGenesInCategory = 10000)
}
\keyword{cluster}

\name{r2cdt}
\alias{r2cdt}
\alias{r2gtr}
\alias{r2atr}
\alias{r2fni}
\title{Functions to generate fTreeView files}
\description{
r2cdt, r2gtr, and r2atr are slightly modified functions from the package ctc.  

r2cdt generates a tab-delimited cdt file from a dataframe where the first column contains gene IDs, the second column contains gene names or descriptions, and the remaining columns represent samples.  Column names are assumed to be sample names.  In addition, corresponding hierarchical gene and sample clusterings are required to re-order genes and samples accordingly.  

r2gtr and r2atr generate tab-delimited TreeView files representing the hierarchical gene and sample clustering, respectively. 

r2fni generates the Functional Node Information file for the Java application fTreeView using an hierarchical gene clustering and corresponding functional Cluster Enrichment Analysis results.  This tab-delimited file is then displayed interactively as the user selects a node (i.e. gene cluster) in the gene tree.  
}
\usage{
r2cdt(hr, hc, data, labels = TRUE, description = TRUE, file = "cluster.cdt", dec = ".")
r2gtr(hr, file = "cluster.gtr", dec = ".")
r2atr(hc, file = "cluster.atr", dec = ".")
r2fni(hr, file = "cluster.fni", clustCategories = NULL, dec = ".")
}
\arguments{
  \item{hr}{An hclust object representing the gene clustering}
  \item{hc}{An hclust object representing the sample clustering}
  \item{data}{A dataframe where the first column may contain gene IDs, the second column may contain gene names or descriptions, and the remaining columns represent samples.  Column names are assumed to be sample names. }
  \item{labels}{If TRUE, the first column of data is assumed to contain gene IDs.}
  \item{description}{If TRUE, the second column of data is assumed to contain gene names or descriptions.}
  \item{file}{The name of the file to be generated.}
  \item{dec}{The character to be used for decimal points.}
  \item{clustCategories}{A list of functional Cluster Enrichment Analysis results. See funcClustAnnot for more details.}
}
\details{
}
\value{
Nothing is returned but a file with the specified name is created.
}
\references{ctc package: http://antoinelucas.free.fr/ctc/

fTreeView: http://eh3.uc.edu/ftreeview}
\author{Johannes Freudenberg}
\note{  
}
\seealso{\code{\link[ctc:ctc-package]{ctc}}, \code{\link{funcClustAnnot}}, \code{\link{hclust}}, \code{\link{call.treeview}}}
\examples{
data(gimmOut)
r2cdt(gimmOut$hGClustData, gimmOut$hSClustData, gimmOut$clustData)
r2gtr(gimmOut$hGClustData)
r2atr(gimmOut$hSClustData)
## not run
# call.treeview("cluster.cdt")
}
\keyword{ IO }
\keyword{ cluster }

\name{gimmOut}
\alias{gimmOut}
\docType{data}
\title{An gimmR object, i.e. a list containing a dataframe with gene expression data, and two hclust objects representing the gene clustering and sample clustering, respectively.}
\description{
  The data set contains log-fold changes for 94 genes in 46 samples under 9 different treatments.  The complete data set (11,498 genes) can be downloaded from the Gene Expression Omnibus (http://www.ncbi.nlm.nih.gov/sites/entrez?db=gds, accession GSE14933)
}
\usage{data(gimmOut)}
\format{
}
\details{
}
\source{
See http://www.ncbi.nlm.nih.gov/geo/query/acc.cgi?acc=GSE14933 for details.
}
\references{
http://www.ncbi.nlm.nih.gov/geo/query/acc.cgi?acc=GSE14933
Medvedovic et al. Influence of fatty acid diets on gene expression in rat mammary epithelial cells. 2009. Physiol Genomics 38(1):80-8.
}
\examples{
## not run
data(gimmOut)
require(CLEAN.Rn)
runCLEAN(gimmOut, species = "Rn")
}
\keyword{datasets}

\name{CLEAN-package}
\alias{CLEAN-package}
\alias{CLEAN}
\docType{package}
\title{
Clustering Enrichment Analysis
}
\description{
Given an hierarchical gene clustering and a list of functional categories, this package performs functional enrichment analysis of all possible clusters and generates files to simultaneously display gene expression data, gene clustering, sample clustering, and functional annotation of gene clustering.
}
\details{
\tabular{ll}{
Package: \tab CLEAN\cr
Type: \tab Package\cr
Version: \tab 1.0\cr
Date: \tab 2008-08-23\cr
License: \tab GPL (>= 2)\cr
LazyLoad: \tab yes\cr
}
}
\author{
Johannes Freudenberg, Xiangdong Liu, Mario Medvedovic

Maintainer: Johannes Freudenberg <freudejm@uc.edu>
}
\references{

}
\keyword{ package }
\seealso{
 \code{\link[gimmR:gimmR-package]{gimmR}}
}
\examples{
data(gimmOut)
require(CLEAN.Rn)
res <- runCLEAN(gimmOut, species = "Rn")

generateTreeViewFiles(gimmOut, functionalCategories=getFunctionalCategories("geneRIFs", species = "Rn"))
#same as 
generateTreeViewFiles(gimmOut, functionalCategories="geneRIFs", species = "Rn")

#multiple category types
generateTreeViewFiles(gimmOut, functionalCategories=c("geneRIFs", "CpGislands", "GO", "KEGG"), species = "Rn")

trt <- sapply(colnames(gimmOut$clustData)[-(1:2)], function(str) strsplit(str, split = "_")[[1]][1])
#not run
#generateTreeViewFiles(gimmOut, cclust = NA, verbose = FALSE, functionalCategories=c("geneRIFs",
#	"CpGislands", "GO", "KEGG"), species = "Rn", callTreeView = TRUE, sampleDesc = trt)
generateTreeViewFiles(gimmOut, cclust = NA, verbose = FALSE, functionalCategories=c("geneRIFs",
	"CpGislands", "GO", "KEGG"), species = "Rn", callTreeView = FALSE, sampleDesc = trt)

#non-hierarchical clustering
d <- nonHierarchicalClustering(function(m, k, ...) kmeans(m, k, ...)$cluster, 
	gimmOut$clustData[,-(1:2)], k = 2:4, nstart = 10)
#not run
#generateTreeViewFiles(gimmOut, rclust = d, cclust = NA, verbose = FALSE, functionalCategories=c("geneRIFs",
#    "CpGislands", "GO", "KEGG"), species = "Rn", callTreeView = TRUE, sampleDesc = trt)
generateTreeViewFiles(gimmOut, rclust = d, cclust = NA, verbose = FALSE, functionalCategories=c("geneRIFs",
    "CpGislands", "GO", "KEGG"), species = "Rn", callTreeView = FALSE, sampleDesc = trt)

#geneList enrichment
geneList <- gimmOut$clustData[,1]
require(org.Rn.eg.db)
allGenes <- unique(keys(org.Rn.egSYMBOL)) #one should really use the list of 
                                          #genes represented on the microarray instead
res <- geneListEnrichment(geneList, allGenes, functionalCategories = "GO", 
	species = "Rn", sigFDR = 0.01, maxGenesInCategory = 10000)
genesInEnrichedCategories(res[,1], geneList, funcCategories = "GO", species = "Rn")

}

\name{plotCLEANscore}
\alias{plotCLEANscore}
\title{Function to generate a diagnostic plot using the CLEAN score}
\description{
    This function generates a plot of the number of genes with CLEANscores <= a threshold against that threshold.  These plots can be used, for example, to compare different clustering algorithms. 
}
\usage{
plotCLEANscore(fClustAnnotations, fCategoryName = "GO", maxCLEANscore = NULL, add = FALSE, ...)
}
\arguments{
  \item{fClustAnnotations}{A list of functional cluster annotations generated by the runCLEAN() function or the generateTreeViewFiles() function}
  \item{fCategoryName}{Name of the list of functional categories to be used for the comparison}
  \item{maxCLEANscore}{Maximal CLEANscore.  If specified, this parameter is used to specify the xlim parameter in the plot() function.}
  \item{add}{If TRUE, plot will be added to existing graph.}
  \item{...}{Additional parameters to the plot() function}
}
\author{Johannes Freudenberg}
\seealso{\code{\link{generateTreeViewFiles}}, \code{\link{runCLEAN}},\code{\link{plot}}, \code{\link{lines}}}
\examples{
## not run
#data(gimmOut)
#require(org.Rn.eg.db)
#allGenes <- unique(keys(org.Rn.egSYMBOL))
# plotCLEANscore is intended for larger datasets. Here we use the larger 
# background gene list to somewhat better demonstrate the 
# plotCLEANscore() function.  In real life, the background list should be
# the list of genes represented on the microarray
#fClustAnnotations <- runCLEAN(gimmOut, bkgList = allGenes, 
#	functionalCategories="CpGislands",species = "Rn", 
#	maxGenesInCategory=10000)
#plotCLEANscore(fClustAnnotations, fCategoryName="CpGislands")
}
\keyword{ aplot }
\keyword{ hplot }
\keyword{ cluster }

\name{LRpath}
\alias{LRpath}
\title{ Testing GO terms or KEGG with logistic regression }
\description{
    This function uses logistic regression to test for enriched biological
    categories in gene expression data. Our method models the probability
    of a randomly selected gene belonging to a specific category given the
    significance level of that gene.  For categories significantly affected by
    the experimental condition, this probability will increase as the significance
    statistic increases.  Categories with significant p-values and positive slope
    coefficients are enriched with differentially expressed genes.
}
\usage{
LRpath(sigvals, geneids, min.g=10, max.g=NA, sig.cutoff=0.05, database="GO", functionalCategories=NULL, 
	odds.min.max=c(0.001,0.5), species="Hs") 
}
\arguments{
  \item{sigvals}{A vector of p-values, same length and order as "geneids"}
  \item{geneids}{A vector of Entrez gene IDs, may contain duplicates and missing values}
  \item{min.g}{The minimum number of unique gene IDs analyzed in category to be tested, default = 10}
  \item{max.g}{The maximum number of unique gene IDs analyzed in category to be tested, default = NA (99999)}
  \item{sig.cutoff}{Entrez gene IDs in each category with p-values<sig.cutoff will be returned, default = 0.05}
  \item{database}{Deprecated. Please use `functionalCategories` instead.}
  \item{functionalCategories}{Functional categories to be tested- currently, options include "GO", "KEGG" and various other categories, default = "GO".  Can be provided by function getFunctionalCategories().}
  \item{odds.min.max}{Lower and upper p-values to be used for odds ratio calculation, default= c(0.001, 0.5)}
  \item{species}{Species to further specify database, human="Hs", mouse="Mm", rat="Rn", etc. Default ="Hs".}
}
\details{
LRpath: testing GO terms or KEGG with logistic regression
Written by: Maureen Sartor, University of Cincinnati, 2008
   
This function uses logistic regression to test for enriched biological
categories in gene expression data. Our method models the probability
of a randomly selected gene belonging to a specific category given the
significance level of that gene.  For categories significantly affected by
the experimental condition, this probability will increase as the significance
statistic increases.  Categories with significant p-values and positive slope
coefficients are enriched with differentially expressed genes.

Please acknowledge your use of LRpath in publications by referencing the Sartor et al. (2009) paper.

}
\value{
Object is a dataframe with the following columns:
GO or KEGG ID   - posterior t-value for IBMT
GO or KEGG term     - name of category
Ontology (only for GO) - BP, MF, or CC
n.genes - Number of unique Entrez Gene IDs in category
coeff - coefficient of slope (only GO terms with positive values are significant)
odds.ratio -  Odds ratio, as measure of strenth of enrichment
p.value -  P-value that slope does not equal zero (that term is enriched)
FDR - False Discovery Rate (Benjamini & Hochberg, 1995)
sig.genes   - comma separated Entrez gene ids in category with p-value<"sig.cutoff"
}
\references{Sartor MA, Leikauf GD, Medvedovic M. 2009. LRpath: A logistic regression approach for identifying enriched 
  biological groups in gene expression data. Bioinformatics 25(2):211-7.}
\author{Maureen Sartor}
\seealso{\code{\link[stats]{glm}}, \code{\link[GO.db:GO.db-package]{GO.db}}, \code{\link[KEGG.db:KEGG.db-package]{KEGG.db}}, \code{\link[gimmR:gimmR-package]{gimmR}}}
\examples{
data(gimmOut)
p <- rbeta(94, 0.5, 2)
LRpath(sigvals=p, geneids=gimmOut$clustData[,1], functionalCategories="GO", species="Rn")
}
\keyword{regression}
\keyword{htest}

\name{getFunctionalCategories}
\alias{getFunctionalCategories}
\title{Retrieve functional categories from species-specific library.}
\description{
  Load the species-specific library/ies and retrieve the functional catogories of type(s) "functionalCategories".
}
\usage{
getFunctionalCategories(functionalCategories, species)
}
\arguments{
  \item{functionalCategories}{A character vector of functional catogory types.}
  \item{species}{Species abreviation such as "Hs", "Mm", or "Rn"}
}
\details{
}
\value{
  A list containing the functional catories and their description (optional).
}
\references{}
\author{Johannes Freudenberg}
\note{ 
}
\seealso{\code{\link{runCLEAN}}}
\examples{
library(CLEAN.Rn)
data(gimmOut)
myFunctionalCategories <- getFunctionalCategories(CLEAN.Rn(), species = "Hs")
generateTreeViewFiles(gimmOut, functionalCategories = myFunctionalCategories)
}
\keyword{data}

\name{genesInEnrichedCategories}
\alias{genesInEnrichedCategories}
\title{Function to intersect a gene list with enriched categories}
\description{
This function takes a gene list and a list of IDs of (enriched) categories and returns a bolean matrix where each column indicates whether or not the gene is member of the corresponding categories.
}
\usage{
genesInEnrichedCategories(categoryIDs, geneList, funcCategories = NULL, species = NULL)
}
\arguments{
  \item{categoryIDs}{A list of functional category IDs.}
  \item{geneList}{A gene list to be tested for enrichment of functional categories.}
  \item{funcCategories}{A collection of gene sets, representing functional categories.}
  \item{species}{Two letter description of the species to be used to generate gene ontology categories (e.g. "Hs" for human, "Mm" for mouse). This parameter is used when funcCategories = "GO"}
}
\details{
coming soon.
}
\value{
  A matrix with rows representing the functional categories and columns representing the genes.
}
\references{Coming soon.}
\author{Johannes Freudenberg, Xiangdong Liu, Mario Medvedovic.}
\note{
}
\seealso{\code{\link{geneListEnrichment}}}
\examples{
data(gimmOut)
require(CLEAN.Rn)
require(org.Rn.eg.db)

geneList <- gimmOut$clustData[,1]
allGenes <- unique(keys(org.Rn.egSYMBOL)) #one should really use the list of
                                          #genes represented on the microarray instead
res <- geneListEnrichment(geneList, allGenes, functionalCategories = "GO",
	species = "Rn", sigFDR = 0.01, maxGenesInCategory = 10000)

#display membership of each gene in top ten categories
genesInEnrichedCategories(res[1:10,1], geneList, funcCategories = "GO", species = "Rn")

}
\keyword{cluster}

\name{getBinarySubTree}
\alias{getBinarySubTree}
\title{Get the left or right subtree of a given hierarchical clustering.}
\description{
  Reads a hierarchical clustering and returns the left or right child of the root node.
}
\usage{
getBinarySubTree(tree, right = FALSE)
}
\arguments{
  \item{tree}{An hclust object}
  \item{right}{If TRUE, return the right subtree, i.e. the right child of the root node.}
}
\details{
}
\value{
  The subtree as an hclust object.
}
\references{}
\author{Johannes Freudenberg, Xiangdong Liu, Mario Medvedovic}
\note{ 
}
\seealso{\code{\link{hclust}}}
\examples{
hc <- hclust(dist(matrix(1:20,5)))
hc$labels <- 1:5
plot(hc)
hc.sub <- getBinarySubTree(hc, TRUE)
plot(hc.sub)
}
\keyword{cluster }

\name{convertFunctionalCategories}
\alias{convertFunctionalCategories}
\title{Function to convert Entrez gene ID-based functional categories from one species to another using the Homologene database}
\description{
    This function loads the Homologene table and a list of functional categories and converts Entrez gene IDs from one species to another.  Currently implemented species are "h" (Homo sapiens), "m" (Mus musculus), and "r" (Rattus norvegicus).  

	Use the following command to download the Homologene table into the working directory:
	> download.file("ftp://ftp.ncbi.nih.gov/pub/HomoloGene/current/homologene.data",destfile="homologene.data",mode="wb")

	This function was adapted from from convertSmc() of the PGSEA package.
}
\usage{
convertFunctionalCategories(functionalCategories, fromSpecies = "h", toSpecies = "r", homologTable = "./homologene.data")
}
\arguments{
  \item{functionalCategories}{A list of functional categories.}
  \item{fromSpecies}{Species the functional categories are currently defined for. Currently implemented species are "h" (Homo sapiens), "m"
  (Mus musculus), and "r" (Rattus norvegicus).}
  \item{toSpecies}{Species the functional categories are to be converted to. Currently implemented species are "h" (Homo sapiens), "m"
  (Mus musculus), and "r" (Rattus norvegicus).}
  \item{homologTable}{File name of the Homologene Table.}
}
\author{Johannes Freudenberg}
\seealso{\code{\link{runCLEAN}}}
\examples{
## not run
# download.file("ftp://ftp.ncbi.nih.gov/pub/HomoloGene/current/homologene.data",destfile="homologene.data",mode="wb")
# library(CLEAN.Hs)
# data(geneRIFs.Hs)
# geneRIFs.Rn <- geneRIFs.Hs
# geneRIFs.Rn$RIFterm2Genes <- convertFunctionalCategories(geneRIFs.Hs$RIFterm2Genes)
}
\keyword{ IO }
